## openturns 1.20

=== CMakeLists.txt ===
#                                               -*- cmake -*-

cmake_minimum_required (VERSION 3.2)

# By default, build in Release mode. Must appear before project() command
if (NOT DEFINED CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type")
endif ()
set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "" Release Debug RelWithDebInfo MinSizeRel)
set (CMAKE_TRY_COMPILE_CONFIGURATION ${CMAKE_BUILD_TYPE})

project (OpenTURNS)

option (USE_BISON                    "Looks for Bison if true and then build parser"                         ON)
option (USE_FLEX                     "Looks for Flex if true and then build lexer"                           ON)
option (USE_TBB                      "Use Intel Threading Building Blocks library for multithreading"        ON)
option (USE_HMAT                     "Use HMat library"                                                      ON)
option (USE_MUPARSER                 "Use muParser library"                                                  ON)
option (USE_EXPRTK                   "Use ExprTK library"                                                    ON)
option (USE_LIBXML2                  "Use LibXml2 for XML support"                                           ON)
option (USE_HDF5                     "Use HDF5 for high volume storage"                                      ON)
option (USE_R                        "Use R for graph output support"                                        ON)
option (USE_BOOST                    "Use Boost for distribution computation"                                ON)
option (USE_MPFR                     "Use MPFR for real valued special functions computation"                ON)
option (USE_MPC                      "Use MPC for complex valued special functions computation"              ON)
option (USE_SPHINX                   "Use sphinx for documentation"                                          ON)
option (USE_DOXYGEN                  "Use Doxygen for API documentation"                                     ON)
option (USE_NLOPT                    "Use NLopt for additional optimization algorithms"                      ON)
option (USE_CERES                    "Use Ceres Solver for additional optimization algorithms"               ON)
option (USE_CMINPACK                 "Use CMinpack for additional optimization algorithms"                   ON)
option (USE_DLIB                     "Use dlib for additional optimization algorithms"                       ON)
option (USE_IPOPT                    "Use Ipopt for nonlinear optimization"                                  ON)
option (USE_BONMIN                   "Use Bonmin for MINLP problems"                                         ON)
option (USE_PAGMO                    "Use Pagmo for multi-objective optimization"                            ON)
option (USE_SPECTRA                  "Use Spectra for eigenvalues computation"                               ON)
option (USE_PRIMESIEVE               "Use primesieve for prime numbers generation"                           ON)
option (USE_OPENMP                   "Use OpenMP to disable threading"                                       ON)
option (USE_OPENBLAS                 "Use OpenBLAS to disable threading"                                     ON)

option (BUILD_PYTHON                 "Build the python module for the library"                               ON)
option (BUILD_SHARED_LIBS            "Build shared libraries"                                                ON)

# Defines our own module path
list (APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

if (POLICY CMP0022)
  # INTERFACE_LINK_LIBRARIES defines the link interface
  cmake_policy (SET CMP0022 NEW)
endif()

if (POLICY CMP0057)
  # Support new IN_LIST if() operator
  cmake_policy (SET CMP0057 NEW)
endif ()

if (POLICY CMP0068)
  # RPATH settings on macOS do not affect install_name
  cmake_policy (SET CMP0068 NEW)
endif ()

if (POLICY CMP0093)
  # FindBoost reports Boost_VERSION in x.y.z format
  cmake_policy (SET CMP0093 NEW)
endif ()

if (POLICY CMP0058)
  # Ninja requires custom command byproducts to be explicit
  cmake_policy (SET CMP0058 NEW)
endif()

if(POLICY CMP0042)
  # Set MACOSX_RPATH to ON
  cmake_policy(SET CMP0042 NEW)
endif()

if (POLICY CMP0054)
  cmake_policy (SET CMP0054 NEW)
endif ()

if (POLICY CMP0056)
  cmake_policy (SET CMP0056 NEW)
endif ()

if (POLICY CMP0066)
  cmake_policy (SET CMP0066 NEW)
endif ()

if (POLICY CMP0074)
  # find_package() uses <PackageName>_ROOT variables
  cmake_policy(SET CMP0074 NEW)
endif ()

if (POLICY CMP0078)
  # swig standard target names
  cmake_policy(SET CMP0078 NEW)
endif ()

if (POLICY CMP0086)
  # UseSWIG honors SWIG_MODULE_NAME via -module flag
  cmake_policy(SET CMP0086 NEW)
endif ()

set (OPENTURNS_HOME_ENV_VAR OPENTURNS_HOME)

if (NOT DEFINED CMAKE_INSTALL_LIBDIR)
  set (CMAKE_INSTALL_LIBDIR lib${LIB_SUFFIX})
endif ()

set (OPENTURNS_LIBRARY_PATH
      ${CMAKE_INSTALL_LIBDIR}
      CACHE PATH "The directory where the library is installed"
   )
set (OPENTURNS_INCLUDE_PATH
      include
      CACHE PATH "The directory where the header files are installed"
   )
set (OPENTURNS_CONFIG_CMAKE_PATH
      ${CMAKE_INSTALL_LIBDIR}/cmake/openturns
      CACHE PATH "The directory where the CMake files are installed"
   )
set (OPENTURNS_SYSCONFIG_PATH
      etc
      CACHE PATH "The directory where the configuration file is installed"
   )
set (OPENTURNS_DATA_PATH
      share
      CACHE PATH "The directory where the common files are installed"
   )
set (OPENTURNS_DOC_PATH
      share/openturns/doc
      CACHE PATH "The directory where the license files are installed"
   )

if (WIN32)
  set (DEFAULT_TMP TEMP)
  set (PATH_SEP "\\;")
else ()
  set(DEFAULT_TMP /tmp)
  set (PATH_SEP ":")
endif()

set (OPENTURNS_TEMPDIR
      ${DEFAULT_TMP}
      CACHE PATH "The directory for temporary files. /tmp by default."
   )
set (TEMPDIR ${OPENTURNS_TEMPDIR})

set (CMAKE_CXX_STANDARD 11)

if (NOT DEFINED LAPACK_LIBRARIES)
  find_package (LAPACK REQUIRED)
  if (LAPACK_FOUND)
    set (OPENTURNS_HAVE_LAPACK TRUE)
  endif ()
endif ()
list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${LAPACK_LIBRARIES})

if (USE_SPECTRA)
  find_package (Spectra 1.0 CONFIG)
endif ()
if (Spectra_FOUND)
  message(STATUS "Found Spectra: ${Spectra_DIR} (found suitable version \"${Spectra_VERSION}\")")
  set (OPENTURNS_HAVE_SPECTRA TRUE)
  list (APPEND OPENTURNS_PRIVATE_LIBRARIES Spectra::Spectra)
  if (NOT TARGET Eigen3::Eigen)
    find_package (Eigen3 CONFIG)
  endif ()
endif()

if (USE_PRIMESIEVE)
  find_package (primesieve CONFIG)
  if (primesieve_FOUND)
    set (OPENTURNS_HAVE_PRIMESIEVE TRUE)
    message (STATUS "Found primesieve: ${primesieve_DIR} (found version ${primesieve_VERSION})")
    list (APPEND OPENTURNS_PRIVATE_LIBRARIES primesieve::primesieve)
  else ()
    # fallback to our macro if primesieveConfig is not provided
    find_package (primesieve)
    if (primesieve_FOUND)
      set (OPENTURNS_HAVE_PRIMESIEVE TRUE)
      list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${PRIMESIEVE_INCLUDE_DIRS})
      list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${PRIMESIEVE_LIBRARIES})
    endif ()
  endif ()
endif ()

if (USE_BISON)
  find_package (BISON 2.4)
  if (BISON_FOUND)
    set (OPENTURNS_HAVE_BISON TRUE)
  endif ()
endif ()

if (USE_FLEX)
  find_package (FLEX)
  if (FLEX_FOUND)
    set (OPENTURNS_HAVE_FLEX TRUE)
  endif ()
endif ()

if (USE_TBB)
  find_package (TBB CONFIG)
  if (TBB_FOUND)
    message (STATUS "Found TBB: ${TBB_DIR} (found version ${TBB_VERSION})")
    set (TBB_LIBRARIES TBB::tbb)
  else ()
    # fallback to our macro
    find_package (TBB 2017)
  endif ()
endif ()
if (TBB_FOUND)
  set (OPENTURNS_HAVE_TBB TRUE)
  if (TBB_INCLUDE_DIRS)
    list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${TBB_INCLUDE_DIRS})
  endif ()
  list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${TBB_LIBRARIES})
  if (MSVC OR WINTEL)
    set (OPENTURNS_TBB_NO_IMPLICIT_LINKAGE ON CACHE BOOL "Prevent implicit linkage against tbb.lib ")
  endif ()
endif ()

if (USE_MUPARSER)
  find_package (muParser 2.2.3 QUIET)
endif ()
if (MUPARSER_FOUND)
  set (OPENTURNS_HAVE_MUPARSER TRUE)
  set (OPENTURNS_HAVE_ANALYTICAL_PARSER TRUE)
  list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${MUPARSER_LIBRARIES})
  list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${MUPARSER_INCLUDE_DIRS})
  set (SYMBOLICPARSER_DEFAULT_BACKEND MuParser)
endif ()
if (USE_EXPRTK)
  set (OPENTURNS_HAVE_EXPRTK TRUE)
  set (OPENTURNS_HAVE_ANALYTICAL_PARSER TRUE)
  set (SYMBOLICPARSER_DEFAULT_BACKEND ExprTk)
endif ()

if (USE_HMAT)
  find_package (HMAT 1.7 CONFIG)
endif ()
if (HMAT_FOUND)
  message(STATUS "Found HMAT: ${HMAT_DIR} (found suitable version \"${HMAT_VERSION}\")")
  set (OPENTURNS_HAVE_HMAT TRUE)
  list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${HMAT_INCLUDE_DIRS})
  list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${HMAT_LIBRARIES})
endif ()

if (USE_DOXYGEN)
  find_package (Doxygen QUIET)
endif ()

if (USE_LIBXML2)
  find_package (LibXml2)
endif ()
if (LIBXML2_FOUND)
  set (OPENTURNS_HAVE_LIBXML2 TRUE)
  list (APPEND OPENTURNS_DEFINITIONS ${LIBXML2_DEFINITIONS})
  list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${LIBXML2_INCLUDE_DIR})
  list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${LIBXML2_LIBRARIES})
endif ()

if (USE_HDF5)
  find_package(HDF5 COMPONENTS C CXX)
endif ()
if (HDF5_FOUND)
  set (OPENTURNS_HAVE_HDF5 TRUE)
  list (APPEND OPENTURNS_DEFINITIONS ${HDF5_DEFINITIONS})
  list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${HDF5_INCLUDE_DIRS})
  list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${HDF5_LIBRARIES})
endif ()

if (MSVC OR WINTEL)
  set (CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${CMAKE_CURRENT_SOURCE_DIR}/lib/include/pthread_win32 ${CMAKE_CURRENT_SOURCE_DIR}/lib/include)
  include_directories (${PROJECT_SOURCE_DIR}/lib/include/pthread_win32 ${CMAKE_CURRENT_SOURCE_DIR}/lib/include)
endif ()
find_package (Threads)
if (Threads_FOUND)
  list (APPEND OPENTURNS_INCLUDE_DIRS ${THREADS_INCLUDE_DIRS})
  list (APPEND OPENTURNS_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})
endif ()

if (USE_BOOST)
  find_package (Boost 1.46)
  if (Boost_FOUND)
    if (CMAKE_VERSION VERSION_LESS 3.15)
      # Boost_VERSION reports the integer BOOST_VERSION from boost/version.hpp instead of x.y.z format
      set (Boost_VERSION "${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION}.${Boost_SUBMINOR_VERSION}")
    endif ()
    set (OPENTURNS_HAVE_BOOST TRUE)
    if (USE_MPFR)
      find_package (MPFR)
      if (MPFR_FOUND)
        set (OPENTURNS_HAVE_MPFR TRUE)
        list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${MPFR_INCLUDE_DIRS})
        list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${MPFR_LIBRARIES})
      endif ()
    endif ()
    if (USE_MPC AND NOT Boost_VERSION VERSION_LESS 1.68)
      find_package (MPC)
      if (MPC_FOUND)
        set (OPENTURNS_HAVE_MPC TRUE)
        list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${MPC_INCLUDE_DIRS})
        list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${MPC_LIBRARIES})
      endif ()
    endif ()
    list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${Boost_INCLUDE_DIRS})
  endif ()
endif ()

if (USE_R)
  find_package (R COMPONENTS base QUIET)
endif ()
if (NOT R_EXECUTABLE)
  set (R_EXECUTABLE "R${CMAKE_EXECUTABLE_SUFFIX}")
endif ()

if (USE_NLOPT)
  find_package (NLopt CONFIG QUIET)
  if (NLopt_FOUND)
    message(STATUS "Found NLopt: ${NLopt_DIR}  (found version \"${NLopt_VERSION}\")")
  else ()
    # fallback to our macro if NLoptConfig is not provided
    find_package (NLopt)
    set (NLopt_FOUND ${NLOPT_FOUND})
  endif ()
  if (NLopt_FOUND)
    set (OPENTURNS_HAVE_NLOPT TRUE)
    list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${NLOPT_INCLUDE_DIRS})
    list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${NLOPT_LIBRARIES})

    try_run (_NLOPT_STOGO_RUNS _NLOPT_STOGO_BUILDS ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_SOURCE_DIR}/cmake/nlopt_have_stogo.cxx LINK_LIBRARIES ${NLOPT_LIBRARIES})
    if (_NLOPT_STOGO_BUILDS)
      if (_NLOPT_STOGO_RUNS EQUAL 0)
        set (OPENTURNS_NLOPT_HAVE_STOGO TRUE)
      else ()

=== lib/CMakeLists.txt ===
#                                               -*- cmake -*-

# Recurse in subdirectories
add_subdirectory (include)
add_subdirectory (src)
add_subdirectory (etc)

# Build the OpenTURNSConfig.cmake file
set (OPENTURNS_LIBRARY_DIRS            ${LIBRARY_PATH})
set (OPENTURNS_LIBRARY                 OT)
list (APPEND OPENTURNS_LIBRARIES       ${OPENTURNS_LIBRARY})
set (OPENTURNS_INCLUDE_DIR             ${INCLUDE_PATH})
list (INSERT OPENTURNS_INCLUDE_DIRS 0  ${OPENTURNS_INCLUDE_DIR})

set (OPENTURNS_ROOT_DIR       ${INSTALL_PATH})
set (OPENTURNS_VERSION_STRING ${PACKAGE_VERSION})
set (OPENTURNS_VERSION_MAJOR  ${CPACK_PACKAGE_VERSION_MAJOR})
set (OPENTURNS_VERSION_MINOR  ${CPACK_PACKAGE_VERSION_MINOR})
set (OPENTURNS_VERSION_PATCH  ${CPACK_PACKAGE_VERSION_PATCH})
set (OPENTURNS_USE_FILE       ${CONFIG_CMAKE_PATH}/UseOpenTURNS.cmake)

include(CMakePackageConfigHelpers)
configure_package_config_file (OpenTURNSConfig.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/OpenTURNSConfig.cmake
  INSTALL_DESTINATION ${OPENTURNS_CONFIG_CMAKE_PATH}
  PATH_VARS
    OPENTURNS_USE_FILE
    OPENTURNS_ROOT_DIR
    OPENTURNS_INCLUDE_DIR
    OPENTURNS_INCLUDE_DIRS
    OPENTURNS_LIBRARY_DIRS
    OPENTURNS_SWIG_INCLUDE_DIRS
    PYTHON_MODULE_PATH
  NO_CHECK_REQUIRED_COMPONENTS_MACRO)

write_basic_package_version_file(OpenTURNSConfigVersion.cmake VERSION ${OPENTURNS_VERSION_STRING} COMPATIBILITY AnyNewerVersion)

install (FILES UseOpenTURNS.cmake
               ${CMAKE_CURRENT_BINARY_DIR}/OpenTURNSConfig.cmake
               ${CMAKE_CURRENT_BINARY_DIR}/OpenTURNSConfigVersion.cmake
         DESTINATION ${OPENTURNS_CONFIG_CMAKE_PATH})

# Recurse in subdirectories : test should be run after src (for target OT to be built)
add_subdirectory (test)

if (DOXYGEN_FOUND)

  # generate Doxyfile
  set (VERSION ${PACKAGE_VERSION})
  set (builddir ${CMAKE_CURRENT_BINARY_DIR})
  set ( top_srcdir ${CMAKE_CURRENT_SOURCE_DIR})
  configure_file (${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
                   ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
                    @ONLY)

  # generate html doc and compress it
  add_custom_target (html 
                      COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/doc
                      COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile
                      COMMAND tar czf doc-api-${PACKAGE_VERSION}.tar.gz doc
                      COMMAND tar cjf doc-api-${PACKAGE_VERSION}.tar.bz2 doc
                     )

endif ()

install (FILES ${HEADERFILES} DESTINATION ${OPENTURNS_INCLUDE_PATH}/openturns)

=== lib/include/CMakeLists.txt ===
#                                               -*- cmake -*-

ot_add_current_dir_to_include_dirs ()
ot_add_build_dir_to_include_dirs (${CMAKE_CURRENT_BINARY_DIR})

string (REGEX REPLACE "(dev|rc[0-9])" "" _VERSION_MINOR "${CPACK_PACKAGE_VERSION_MINOR}")
math (EXPR OPENTURNS_VERSION_NR "100000 * ${CPACK_PACKAGE_VERSION_MAJOR} + 100 * ${_VERSION_MINOR}")
if (CPACK_PACKAGE_VERSION_PATCH)
  math (EXPR OPENTURNS_VERSION_NR "${OPENTURNS_VERSION_NR} + ${CPACK_PACKAGE_VERSION_PATCH}")
endif ()


configure_file (${CMAKE_CURRENT_SOURCE_DIR}/OTconfig.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/openturns/OTconfig.h
                @ONLY)

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/installed-OTconfig.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/openturns/installed-OTconfig.h
                @ONLY)

if (NOT ot_configure_date)
  if (UNIX)
    execute_process (COMMAND date "+%a, %d %b %Y %H:%M:%S %z"
                      OUTPUT_VARIABLE ot_configure_date
                      OUTPUT_STRIP_TRAILING_WHITESPACE
                   )
  elseif(MSVC OR WINTEL)
    execute_process (COMMAND cmd " /C date /T"
                      OUTPUT_VARIABLE ot_configure_date
                      OUTPUT_STRIP_TRAILING_WHITESPACE)
  endif()
  set (ot_configure_date "${ot_configure_date}" CACHE STRING "First configure date.")
endif ()
if (NOT ot_revision)
  execute_process (COMMAND git rev-parse --short HEAD
                    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
                    OUTPUT_VARIABLE ot_revision
                    OUTPUT_STRIP_TRAILING_WHITESPACE
                 )
  set (ot_revision "${ot_revision}" CACHE STRING "Revision number.")
endif ()
mark_as_advanced(ot_configure_date ot_revision)
set (prefix ${CMAKE_INSTALL_PREFIX})
set (PACKAGE openturns)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/OTconfigure_args.hxx.in
                ${CMAKE_CURRENT_BINARY_DIR}/openturns/OTconfigureArgs.hxx
                @ONLY
             )

# with in-source build, installed-OTconfig.h must overwrite the internal openturns/OTconfig.h
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/openturns/installed-OTconfig.h
          DESTINATION ${OPENTURNS_INCLUDE_PATH}/openturns
          RENAME OTconfig.h
       )
install (DIRECTORY openturns DESTINATION ${OPENTURNS_INCLUDE_PATH})

if (MSVC OR WINTEL)
    install (FILES pthread_win32/pthread.h
                    pthread_win32/semaphore.h
                    pthread_win32/unistd.h
              DESTINATION ${OPENTURNS_INCLUDE_PATH}
           )
endif ()

=== lib/src/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()
ot_install_header_file (OT.hxx)
ot_add_source_file (openturns_library_ok.c)

# Recurse in subdirectories
add_subdirectory (Base)
add_subdirectory (Uncertainty)

set_source_files_properties (Base/Func/SpecFunc/Faddeeva.cc PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)

# Exclude Ceres sources from unity build (templates take much memory)
if (Ceres_FOUND)
  set_source_files_properties (Base/Optim/Ceres.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# Exclude Dlib sources from unity build (Lapack re-included)
if (dlib_FOUND)
  set_source_files_properties (Base/Optim/Dlib.cxx Base/Optim/DlibFunctions.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# Exclude Ipopt sources
if (Ipopt_FOUND)
  set_source_files_properties (Base/Optim/Ipopt.cxx Base/Optim/IpoptProblem.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# Exclude Bonmin sources
if (Bonmin_FOUND)
  set_source_files_properties (Base/Optim/Bonmin.cxx Base/Optim/BonminProblem.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
  if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7)
      set_source_files_properties (Base/Optim/Bonmin.cxx Base/Optim/BonminProblem.cxx PROPERTIES COMPILE_FLAGS "-Wno-error=unused-parameter")
    else ()
      set_source_files_properties (Base/Optim/Bonmin.cxx Base/Optim/BonminProblem.cxx PROPERTIES COMPILE_FLAGS "-Wno-error=unused-parameter -Wno-error=implicit-fallthrough")
    endif ()
  endif ()
endif ()

if (Pagmo_FOUND)
  set_source_files_properties (Base/Optim/Pagmo.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# Exclude LibXML sources
if (LIBXML2_FOUND)
  set_source_files_properties (Base/Common/XMLStorageManager.cxx Base/Common/XMLToolbox.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# Exclude HDF5 sources
if (LIBXML2_FOUND AND HDF5_FOUND)
  set_source_files_properties (Base/Common/XMLH5StorageManager.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# Exclude HMAT sources
if (HMAT_FOUND)
  set_source_files_properties (Base/Stat/HMatrixFactory.cxx Base/Stat/HMatrixImplementation.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
endif ()

# SymbolicParserExprTk.cxx includes exprtk.hpp which is huge, exclude it from unity builds
# It also causes problems on Windows
if (OPENTURNS_HAVE_EXPRTK)
  set_source_files_properties ("Base/Func/SymbolicParserExprTk.cxx" PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
  if (MINGW)
    set_source_files_properties ("Base/Func/SymbolicParserExprTk.cxx" PROPERTIES COMPILE_FLAGS "-Wa,-mbig-obj -g0")
  elseif (WIN32 AND CMAKE_CXX_COMPILER_ID MATCHES "MSVC|Intel")
    set_source_files_properties ("Base/Func/SymbolicParserExprTk.cxx" PROPERTIES COMPILE_FLAGS "/bigobj")
  endif ()
endif()

# Exclude spectra sources from unity build (templates take a lot of memory)
if (Spectra_FOUND)
  set_source_files_properties (Base/Algo/KarhunenLoeveP1Algorithm.cxx PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
  if (CMAKE_CXX_COMPILER_ID MATCHES "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 12)
    set_source_files_properties (Base/Algo/KarhunenLoeveP1Algorithm.cxx PROPERTIES COMPILE_FLAGS "-Wno-error=use-after-free")
  endif ()
endif ()

# Build main library
foreach (built_source ${BUILT_SOURCEFILES})
  set_source_files_properties (${built_source} PROPERTIES GENERATED TRUE)
endforeach (built_source)
include_directories (BEFORE ${INTERNAL_INCLUDE_DIRS})
add_library (OT ${SOURCEFILES} ${BUILT_SOURCEFILES})
set_target_properties (OT PROPERTIES POSITION_INDEPENDENT_CODE ON)

if (BUILD_SHARED_LIBS)
  set_target_properties(OT PROPERTIES COMPILE_DEFINITIONS "OT_DLL_EXPORTS")
endif ()

# soversion
set_target_properties (OT PROPERTIES SOVERSION 0.21)
set_target_properties (OT PROPERTIES VERSION 0.21.0)

if (BISON_FOUND AND FLEX_FOUND)
  add_dependencies (OT generate_csv_lexer)
  add_dependencies (OT generate_csv_parser)
endif ()

target_link_libraries (OT PUBLIC ${OPENTURNS_LIBRARIES})
target_link_libraries (OT PRIVATE ${OPENTURNS_PRIVATE_LIBRARIES})

target_include_directories (OT INTERFACE $<INSTALL_INTERFACE:include>)
target_include_directories (OT PUBLIC ${OPENTURNS_INCLUDE_DIRS})

if (NOT CMAKE_VERSION VERSION_LESS 3.8)
  target_compile_features(OT PUBLIC cxx_std_11)
endif ()

# Build an empty executable to check link dependencies and completeness
add_executable (linktest main.cxx)
target_link_libraries (linktest OT)
set_target_properties (linktest PROPERTIES
                                 INSTALL_RPATH "${CMAKE_INSTALL_RPATH};${CMAKE_BINARY_DIR}/lib/src")

# Add targets to the build-tree export set
export(TARGETS OT FILE "${PROJECT_BINARY_DIR}/OpenTURNS-Targets.cmake")

# Install the export set for use with the install-tree
install(EXPORT OpenTURNS-Targets DESTINATION ${OPENTURNS_CONFIG_CMAKE_PATH} COMPONENT Development)

# Install rules for library and executable
install (TARGETS OT
          EXPORT  OpenTURNS-Targets
          RUNTIME DESTINATION bin
	  LIBRARY DESTINATION ${OPENTURNS_LIBRARY_PATH}
	  ARCHIVE DESTINATION ${OPENTURNS_LIBRARY_PATH}
       )

if (UNIX AND BUILD_SHARED_LIBS)
  set (OT_GDB_PY ${CMAKE_SHARED_LIBRARY_PREFIX}OT${CMAKE_SHARED_LIBRARY_SUFFIX}.${LIB_VERSION}-gdb.py)
  execute_process (COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/libOT-gdb.py ${CMAKE_CURRENT_BINARY_DIR}/${OT_GDB_PY})
  install (FILES libOT-gdb.py DESTINATION ${OPENTURNS_DATA_PATH}/gdb/auto-load/${LIBRARY_PATH} RENAME ${OT_GDB_PY})
endif ()

=== lib/test/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  Copyright 2005-2022 Airbus-EDF-IMACS-ONERA-Phimeca
#
#  This library is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with this library.  If not, see <http://www.gnu.org/licenses/>.
#
#

if (MINGW AND CMAKE_SIZEOF_VOID_P EQUAL 4)
  add_library (CRT_fp8 STATIC EXCLUDE_FROM_ALL CRT_fp8.c)
endif ()

set (CHECK_ENVIRONMENT "OPENTURNS_CONFIG_PATH=${CMAKE_BINARY_DIR}/lib/etc")

# This macro compiles on the fly and run the corresponding pre-installation test
# It can have two optional arguments PRE and POST followed by some shell command to be run
# before or after the test if needed
# PRE and POST options cn be repeated many times: the arguments will be run one after the other
# in the order of appearence. If one fails, the whole command fails.
set (CHECK_TO_BE_RUN)
macro (ot_check_test TESTNAME)
  set (TESTNAME_TGT t_${TESTNAME})
  set (TESTNAME_SRC ${TESTNAME_TGT}.cxx)
  set (TESTNAME_SRCS ${TESTNAME_SRC})
  add_executable (${TESTNAME_TGT} EXCLUDE_FROM_ALL ${TESTNAME_SRCS})
  add_dependencies(tests ${TESTNAME_TGT}) 
  target_link_libraries (${TESTNAME_TGT} OT)
  if (MINGW AND CMAKE_SIZEOF_VOID_P EQUAL 4)
    target_link_libraries (${TESTNAME_TGT} CRT_fp8)
  endif ()
  set_target_properties (${TESTNAME_TGT} PROPERTIES
                         UNITY_BUILD OFF
                         INSTALL_RPATH "${CMAKE_BINARY_DIR}/lib/src;${CMAKE_INSTALL_RPATH}")
  set (TESTNAME_LOC ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}${CMAKE_EXECUTABLE_SUFFIX})

  set (_CMD)
  set (_PARAMS)
  set (_IGNOREOUT OFF)
  foreach (_ARG ${ARGN})
    string (TOUPPER ${_ARG} ARG)
    if (${ARG} MATCHES PARAMS)
      set (_CMD PARAMS)
    elseif (${ARG} MATCHES IGNOREOUT)
      set (_IGNOREOUT ON)
    else ()
      if (${_CMD} MATCHES PARAMS)
        set (_PARAMS "${_PARAMS} ${_ARG}")
      endif ()
      set (_CMD)
    endif ()
  endforeach ()

  if (_IGNOREOUT)
    set (COMMAND "(${CMAKE_CROSSCOMPILING_EMULATOR} ${TESTNAME_LOC} ${_PARAMS} > /dev/null)")
  else (_IGNOREOUT)
    set (TESTNAME_OUT ${TESTNAME_TGT}.expout)
    set (OUTFILE_LOC ${CMAKE_CURRENT_SOURCE_DIR}/${TESTNAME_OUT})
    set (COMMAND "(${CMAKE_CROSSCOMPILING_EMULATOR} ${TESTNAME_LOC} ${_PARAMS} > ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out) && diff -u --strip-trailing-cr ${OUTFILE_LOC} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out")
  endif ()

  add_test (cppcheck_${TESTNAME} "sh" "-c" "${COMMAND}")
  set_tests_properties (cppcheck_${TESTNAME} PROPERTIES ENVIRONMENT "${CHECK_ENVIRONMENT}")
  list (APPEND CHECK_TO_BE_RUN ${TESTNAME_TGT})
endmacro ()


include_directories (BEFORE ${INTERNAL_INCLUDE_DIRS})

## Pre-installation tests

# Common
ot_check_test (Object_std)
ot_check_test (OStream_std)
ot_check_test (PersistentObject_std)
ot_check_test (Pointer_std)
ot_check_test (Pointer_cast)
ot_check_test (Exception_std IGNOREOUT)
ot_check_test (Log_std)
ot_check_test (IdFactory_std IGNOREOUT)
ot_check_test (ComparisonOperator_std)
if (LIBXML2_FOUND)
  ot_check_test (Study_saveload)
  if (HDF5_FOUND)
    ot_check_test (Study_h5)
  endif ()
endif ()
ot_check_test (ResourceMap_std IGNOREOUT)
ot_check_test (Catalog_std IGNOREOUT)
ot_check_test (AtomicInt_std IGNOREOUT)

# Type
ot_check_test (Collection_std)
ot_check_test (Indices_std)
ot_check_test (IndicesCollection_std)
ot_check_test (Description_std)
ot_check_test (Point_std)
ot_check_test (Point_description)
ot_check_test (Matrix_std)
ot_check_test (SparseMatrix_std)
ot_check_test (IdentityMatrix_std)
ot_check_test (Tensor_std)
ot_check_test (ComplexTensor_std)
ot_check_test (SymmetricTensor_std)
ot_check_test (SquareMatrix_std)
ot_check_test (TriangularMatrix_std)
ot_check_test (SymmetricMatrix_std)
ot_check_test (Matrix_solve)
ot_check_test (Matrix_decomposition)
ot_check_test (SquareMatrix_lapack)
ot_check_test (SymmetricMatrix_lapack)
ot_check_test (Cache_std)
ot_check_test (ComplexMatrix_std)
ot_check_test (SquareComplexMatrix_std)
ot_check_test (HermitianMatrix_std)
ot_check_test (TriangularComplexMatrix_std)

# Func
ot_check_test (LinearEvaluation_std)
ot_check_test (ConstantGradient_std)
ot_check_test (AggregatedEvaluation_std)
ot_check_test (PiecewiseLinearEvaluation_std)
ot_check_test (PiecewiseHermiteEvaluation_std)
ot_check_test (P1LagrangeEvaluation_std)
if (OPENTURNS_HAVE_EXPRTK)
ot_check_test (SymbolicEvaluation_std)
ot_check_test (SymbolicGradient_std)
ot_check_test (SymbolicHessian_std)
ot_check_test (SymbolicFunction_std)
endif ()
if (OPENTURNS_HAVE_MUPARSER)
ot_check_test (SymbolicEvaluation_muparser)
ot_check_test (SymbolicGradient_muparser)
ot_check_test (SymbolicHessian_muparser)
ot_check_test (SymbolicFunction_muparser)
endif ()
ot_check_test (TranslationFunction_std)
ot_check_test (LinearFunction_std)
ot_check_test (LinearCombinationEvaluation_std)
ot_check_test (LinearCombinationGradient_std)
ot_check_test (LinearCombinationHessian_std)
ot_check_test (QuadraticEvaluation_std)
ot_check_test (LinearGradient_std)
ot_check_test (ConstantHessian_std)
ot_check_test (MethodBoundEvaluation_std)
ot_check_test (IndicatorFunction_std IGNOREOUT)
ot_check_test (DistanceToDomainFunction_std IGNOREOUT)
ot_check_test (AggregatedFunction_std)
ot_check_test (DualLinearCombinationFunction_std)
ot_check_test (LinearCombinationFunction_std)
ot_check_test (Function_operations)
ot_check_test (ParametricFunction_std)
ot_check_test (DatabaseFunction_std)
ot_check_test (MemoizeFunction_std)

ot_check_test (Function_draw)
ot_check_test (MonomialFunction_std)
ot_check_test (MonomialFunctionFactory_std)
ot_check_test (TensorizedUniVariateFunctionFactory_std)

ot_check_test (UniVariatePolynomial_std)
ot_check_test (Basis_std)
ot_check_test (BasisSequence_std)
ot_check_test (LARS_std)
ot_check_test (FieldFunction_std)
ot_check_test (FieldToPointFunction_std)
ot_check_test (PointToFieldFunction_std)
ot_check_test (ValueFunction_std)
ot_check_test (VertexValueFunction_std)
ot_check_test (PointToPointEvaluation_std)
ot_check_test (PointToPointConnection_std)
ot_check_test (PointToFieldConnection_std)
ot_check_test (FieldToPointConnection_std)
ot_check_test (FieldToFieldConnection_std)
ot_check_test (BoxCoxEvaluation_std)
ot_check_test (BoxCoxTransform_std)
ot_check_test (InverseBoxCoxEvaluation_std)
ot_check_test (InverseBoxCoxTransform_std)
ot_check_test (TrendEvaluation_std)
ot_check_test (TrendTransform_std)
ot_check_test (InverseTrendEvaluation_std)
ot_check_test (InverseTrendTransform_std)
ot_check_test (ExpertMixture_std)
ot_check_test (BasisFactory_std)

# Optim
ot_check_test (AbdoRackwitz_std)
if (Ceres_FOUND)
ot_check_test (Ceres_std)
endif ()
if (CMinpack_FOUND)
ot_check_test (CMinpack_std)
endif ()
ot_check_test (Cobyla_std)
if (dlib_FOUND)
  ot_check_test (Dlib_std IGNOREOUT)
  if (dlib_VERSION VERSION_GREATER 19.7)
    ot_check_test (Dlib_global IGNOREOUT)
  endif()
endif()
if (Bonmin_FOUND)
  ot_check_test (Bonmin_std IGNOREOUT)
endif()

ot_check_test (SQP_std)
ot_check_test (TNC_std)
ot_check_test (NearestPointChecker_std)
if (NLopt_FOUND)
ot_check_test (NLopt_std)
endif ()
ot_check_test (MultiStart_std)

# Solver
ot_check_test (Bisection_std)
ot_check_test (Brent_std)
ot_check_test (Secant_std)
ot_check_test (RungeKutta_std)
ot_check_test (Fehlberg_std)

# Stat
ot_check_test (Sample_std)
ot_check_test (Sample_split)
ot_check_test (Sample_large)
ot_check_test (Sample_computation)
ot_check_test (Sample_operators)
ot_check_test (HistoryStrategy_std)
ot_check_test (CovarianceMatrix_std)
ot_check_test (CorrelationMatrix_std)
ot_check_test (TestResult_std)
ot_check_test (Field_draw)
ot_check_test (Field_std)
ot_check_test (ProcessSample_std)
ot_check_test (RandomGenerator_std)
ot_check_test (SobolSequence_std)
ot_check_test (FaureSequence_std)
ot_check_test (HaltonSequence_std)
ot_check_test (HaselgroveSequence_std)
ot_check_test (ReverseHaltonSequence_std)
ot_check_test (CorrelationAnalysis_std IGNOREOUT)
ot_check_test (TimeSeries_std)
ot_check_test (FilteringWindows_std)
ot_check_test (WelchFactory_std)
ot_check_test (ExponentialModel_std)
ot_check_test (CovarianceModel_std IGNOREOUT)
ot_check_test (DiracCovarianceModel_std)
ot_check_test (ExponentiallyDampedCosineModel_std)
ot_check_test (CauchyModel_std)
ot_check_test (UserDefinedSpectralModel_std)
ot_check_test (UserDefinedCovarianceModel_std)
ot_check_test (UserDefinedStationaryCovarianceModel_std)
ot_check_test (StationaryCovarianceModelFactory_std)
ot_check_test (NonStationaryCovarianceModelFactory_std)
if (HMAT_FOUND)
ot_check_test (HMatrix_LDLt)
ot_check_test (HMatrix_LLt)
ot_check_test (HMatrix_LU)
# FIXME: fails on xenial, assume its due to gcc 5.x
if (NOT (CMAKE_CXX_COMPILER_ID MATCHES "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6))
  ot_check_test (HMatrix_block_LLt)
endif ()
ot_check_test (HMatrix_block_LU)
ot_check_test (DiracCovarianceModel_hmat)
endif ()

# Diff
ot_check_test (FiniteDifferenceStep_std)

# Geom
ot_check_test (Domain_std)
ot_check_test (Interval_std)
ot_check_test (IntervalMesher_std)
ot_check_test (LevelSet_std)
ot_check_test (LevelSetMesher_std)
ot_check_test (Mesh_std)
ot_check_test (Mesh_draw)
ot_check_test (RegularGrid_std)
ot_check_test (DomainComplement_std)
ot_check_test (DomainDifference_std)
ot_check_test (DomainIntersection_std)
ot_check_test (DomainUnion_std)
ot_check_test (DomainDisjunctiveUnion_std)

# Graph
ot_check_test (BarPlot_std)
ot_check_test (Cloud_std)
ot_check_test (Contour_std)
ot_check_test (Curve_std)
ot_check_test (Drawable_std)
ot_check_test (Graph_mix)
ot_check_test (Pie_std)
ot_check_test (Polygon_std)
ot_check_test (PolygonArray_std)
ot_check_test (Staircase_std)
ot_check_test (Text_std)

# Algo
ot_check_test (PenalizedLeastSquaresAlgorithm_std)
ot_check_test (CorrectedLeaveOneOut_std)
ot_check_test (KDTree_std)
ot_check_test (RegularGridNearestNeighbour_std)
ot_check_test (NaiveNearestNeighbour_std)
ot_check_test (NearestNeighbour1D_std)
ot_check_test (BoundingVolumeHierarchy_std)
ot_check_test (NaiveEnclosingSimplex_std)
ot_check_test (RegularGridEnclosingSimplex_std IGNOREOUT)
ot_check_test (EnclosingSimplexMonotonic1D_std IGNOREOUT)
ot_check_test (KFold_std)
ot_check_test (LeastSquaresMetaModelSelectionFactory_std)
ot_check_test (KissFFT_std)
ot_check_test (FilonQuadrature_std)
ot_check_test (GaussKronrod_std)
ot_check_test (GaussLegendre_std)
ot_check_test (FejerAlgorithm_std IGNOREOUT)
ot_check_test (IteratedQuadrature_std)
ot_check_test (KarhunenLoeveP1Algorithm_std)
if (OPENTURNS_HAVE_HMAT AND OPENTURNS_HAVE_SPECTRA)
  ot_check_test (KarhunenLoeveP1Algorithm_hmat)
endif ()
if (OPENTURNS_HAVE_SPECTRA)
  ot_check_test (KarhunenLoeveP1Algorithm_spectra)
endif ()
ot_check_test (DesignProxy_std)
ot_check_test (LeastSquaresMethod_std)
ot_check_test (LeastSquaresMethod_weighted)
ot_check_test (KarhunenLoeveSVDAlgorithm_std)
ot_check_test (KarhunenLoeveLifting_std)
ot_check_test (KarhunenLoeveProjection_std)
ot_check_test (P1LagrangeInterpolation_std)

# Analytical
ot_check_test (Analytical_std)
ot_check_test (AnalyticalResult_std)
ot_check_test (FORM_std)
ot_check_test (FORM_AbdoRackwitz)
ot_check_test (FORM_SQP)
ot_check_test (FORM_sensitivity)
ot_check_test (FORM_draw)
ot_check_test (SORM_std)
ot_check_test (StrongMaximumTest_std)
ot_check_test (StrongMaximumTest_tabulatedValues)
ot_check_test (StrongMaximumTest_other)

# Distribution
ot_check_test (Arcsine_std)
ot_check_test (ArcsineFactory_std)
ot_check_test (Bernoulli_std)

=== python/src/CMakeLists.txt ===
#                                               -*- cmake -*-

add_definitions (${OPENTURNS_SWIG_DEFINITIONS})

set (CMAKE_SWIG_FLAGS "" CACHE STRING "SWIG flags for generating wrapper code")

# allows one to pass compile flags like -O1 to reduce memory usage
set (SWIG_COMPILE_FLAGS "" CACHE STRING "C++ compiler flags used for wrapper code")

if (NOT DEFINED PYTHON_EXTENSION_MODULE_SUFFIX AND NOT CMAKE_CROSSCOMPILING)
  execute_process (COMMAND ${PYTHON_EXECUTABLE} -c "import importlib.machinery; print(importlib.machinery.EXTENSION_SUFFIXES[0])"
                   OUTPUT_VARIABLE PYTHON_EXTENSION_MODULE_SUFFIX OUTPUT_STRIP_TRAILING_WHITESPACE)
endif ()

# generate SWIG runtime header
execute_process (COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/openturns)
add_custom_command (OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/openturns/swigpyrun.h
                     COMMAND ${SWIG_EXECUTABLE}
                     ARGS -python -external-runtime ${CMAKE_CURRENT_BINARY_DIR}/openturns/swigpyrun.h
                     COMMENT "Swig runtime header")
add_custom_target (generate_swig_runtime DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/openturns/swigpyrun.h)
add_custom_target (generate_docstrings)
add_custom_target (pylib)

include_directories (BEFORE ${CMAKE_CURRENT_BINARY_DIR})
include_directories (BEFORE ${INTERNAL_INCLUDE_DIRS})
include_directories (BEFORE ${CMAKE_CURRENT_SOURCE_DIR})

set (OPENTURNS_PYTHON_MODULES)
macro (ot_add_python_module MODULENAME SOURCEFILE)
  set_source_files_properties (${SOURCEFILE} PROPERTIES CPLUSPLUS ON)
  set_source_files_properties (${SOURCEFILE} PROPERTIES SWIG_MODULE_NAME ${MODULENAME})
  ot_install_swig_file (${SOURCEFILE})
  if (${ARGC} GREATER 2)
    set (SWIG_MODULE_${MODULENAME}_EXTRA_DEPS ${ARGN})
  endif ()
  list (APPEND SWIG_MODULE_${MODULENAME}_EXTRA_DEPS generate_docstrings openturns/PythonWrappingFunctions.hxx)

  set (swig_other_sources)
  foreach (it ${ARGN})
    if (${it} MATCHES ".*\\.i$")
      ot_install_swig_file (${it})
    elseif(${it} MATCHES ".*_doc\\.i\\.in$")
     # handle docstring generation
      set (DOCSTRING_IN_FILE ${CMAKE_CURRENT_SOURCE_DIR}/${it})
      get_filename_component (DOCSTRING_FILE_BASENAME ${DOCSTRING_IN_FILE} NAME_WE)
      # https://github.com/swig/swig/issues/1273
      option (SWIG_FORCE_DOUBLE_ESCAPE_BACKSLASH "Force double escaping of backslashes" OFF)
      mark_as_advanced (SWIG_FORCE_DOUBLE_ESCAPE_BACKSLASH)
      set (TIMES x1)
      if ((SWIG_VERSION VERSION_LESS 4) OR SWIG_FORCE_DOUBLE_ESCAPE_BACKSLASH)
        set (TIMES x2)
      endif ()
      add_custom_target (generate_${DOCSTRING_FILE_BASENAME}
                          COMMAND ${CMAKE_COMMAND} -DDOCSTRING_IN_FILE=${DOCSTRING_IN_FILE} -DDOCSTRING_FILE=${CMAKE_CURRENT_BINARY_DIR}/${DOCSTRING_FILE_BASENAME}.i -DTIMES=${TIMES} -P ${CMAKE_SOURCE_DIR}/cmake/escape_backslash.cmake
                          DEPENDS ${DOCSTRING_IN_FILE})
      add_dependencies (generate_docstrings generate_${DOCSTRING_FILE_BASENAME})
      list (APPEND SWIGFILES ${CMAKE_CURRENT_BINARY_DIR}/${DOCSTRING_FILE_BASENAME}.i)
    else ()
      list (APPEND swig_other_sources "${it}")
    endif ()
  endforeach ()

  # swig_add_module is deprecated
  if (CMAKE_VERSION VERSION_LESS 3.8)
    swig_add_module (${MODULENAME} python ${SOURCEFILE} ${swig_other_sources})
  else ()
    swig_add_library (${MODULENAME} LANGUAGE python SOURCES ${SOURCEFILE} ${swig_other_sources})
  endif ()

  # UseSWIG generates now standard target names
  if (CMAKE_VERSION VERSION_LESS 3.13)
    set (module_target ${SWIG_MODULE_${MODULENAME}_REAL_NAME})
  else ()
    set (module_target ${MODULENAME})
  endif ()

  add_dependencies (${module_target} generate_swig_runtime)
  swig_link_libraries (${MODULENAME} OT)

  target_link_libraries_with_dynamic_lookup (${module_target} ${PYTHON_LIBRARIES})

  set_target_properties (${module_target} PROPERTIES COMPILE_FLAGS "${SWIG_COMPILE_FLAGS}")

  set_target_properties (${module_target} PROPERTIES UNITY_BUILD OFF)

  if (DEFINED PYTHON_EXTENSION_MODULE_SUFFIX)
    set_target_properties (${module_target} PROPERTIES SUFFIX "${PYTHON_EXTENSION_MODULE_SUFFIX}")
  endif ()

  install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${MODULENAME}.py
           DESTINATION ${OPENTURNS_PYTHON_MODULE_PATH}/openturns)
  install (TARGETS ${module_target}
            LIBRARY DESTINATION ${OPENTURNS_PYTHON_MODULE_PATH}/openturns)

  add_dependencies (pylib ${module_target})
  list (APPEND OPENTURNS_PYTHON_MODULES ${MODULENAME})
endmacro ()

install (DIRECTORY openturns DESTINATION ${OPENTURNS_INCLUDE_PATH})

if (LIBXML2_FOUND AND CMAKE_VERSION VERSION_LESS 3.12)
  list (APPEND SWIG_MODULE_common_EXTRA_FLAGS -DOPENTURNS_HAVE_LIBXML2=1)
endif ()

if (HDF5_FOUND AND CMAKE_VERSION VERSION_LESS 3.12)
  list (APPEND SWIG_MODULE_common_EXTRA_FLAGS -DOPENTURNS_HAVE_HDF5=1)
endif ()

ot_add_python_module(common common_module.i
                      OTtypes.i
                      OTexceptions.i
                      TBB.i TBB_doc.i.in
                      Object.i Object_doc.i.in
                      PersistentObject.i PersistentObject_doc.i.in
                      Study.i Study_doc.i.in
                      StorageManager.i StorageManager_doc.i.in
                      XMLStorageManager.i XMLStorageManager_doc.i.in
                      XMLH5StorageManager.i XMLH5StorageManager_doc.i.in
                      Log.i Log_doc.i.in
                      TTY.i TTY_doc.i.in
                      Path.i Path_doc.i.in
                      Catalog.i
                      ResourceMap.i ResourceMap_doc.i.in
                      ComparisonOperatorImplementation.i
                      ComparisonOperator.i ComparisonOperator_doc.i.in
                      Equal.i Equal_doc.i.in
                      Greater.i Greater_doc.i.in
                      GreaterOrEqual.i GreaterOrEqual_doc.i.in
                      Less.i Less_doc.i.in
                      LessOrEqual.i LessOrEqual_doc.i.in
                      Cache.i
                      Pointer.i
                      InterfaceObject.i InterfaceObject_doc.i.in
                      TypedInterfaceObject.i
                      TypedCollectionInterfaceObject.i
                      BaseCommonTemplateDefs.i
                   )

if (LIBXML2_FOUND AND NOT CMAKE_VERSION VERSION_LESS 3.12)
  set_property (TARGET ${SWIG_MODULE_common_REAL_NAME} APPEND PROPERTY SWIG_COMPILE_DEFINITIONS OPENTURNS_HAVE_LIBXML2=1)
endif ()

if (HDF5_FOUND AND NOT CMAKE_VERSION VERSION_LESS 3.12)
  set_property (TARGET ${SWIG_MODULE_common_REAL_NAME} APPEND PROPERTY SWIG_COMPILE_DEFINITIONS OPENTURNS_HAVE_HDF5=1)
endif ()

ot_add_python_module(typ typ_module.i
                      Collection.i Collection_doc.i.in
                      PersistentCollection.i
                      Description.i Description_doc.i.in
                      PlatformInfo.i PlatformInfo_doc.i.in
                      Point.i Point_doc.i.in
                      PointWithDescription.i PointWithDescription_doc.i.in
                      DomainImplementation.i DomainImplementation_doc.i.in
                      Interval.i Interval_doc.i.in
                      Indices.i Indices_doc.i.in
                      IndicesCollection.i IndicesCollection_doc.i.in
                      IndicesCollectionImplementation.i
                      MatrixImplementation.i
                      Matrix.i Matrix_doc.i.in
                      SquareMatrix.i SquareMatrix_doc.i.in
                      SymmetricMatrix.i SymmetricMatrix_doc.i.in
                      TensorImplementation.i TensorImplementation_doc.i.in
                      Tensor.i Tensor_doc.i.in
                      SymmetricTensor.i SymmetricTensor_doc.i.in
                      ComplexTensorImplementation.i
                      ComplexTensor.i ComplexTensor_doc.i.in
                      ComplexMatrixImplementation.i ComplexMatrixImplementation_doc.i.in
                      ComplexMatrix.i ComplexMatrix_doc.i.in
                      HermitianMatrix.i HermitianMatrix_doc.i.in
                      SquareComplexMatrix.i SquareComplexMatrix_doc.i.in
                      TriangularMatrix.i TriangularMatrix_doc.i.in
                      TriangularComplexMatrix.i TriangularComplexMatrix_doc.i.in
                      CovarianceMatrix.i CovarianceMatrix_doc.i.in
                      CorrelationMatrix.i CorrelationMatrix_doc.i.in
                      IdentityMatrix.i IdentityMatrix_doc.i.in
                      Sample.i Sample_doc.i.in
                      HistoryStrategyImplementation.i HistoryStrategyImplementation_doc.i.in
                      HistoryStrategy.i HistoryStrategy_doc.i.in
                      BaseTypCollection.i
                      BaseTypTemplateDefs.i
                   )

ot_add_python_module(statistics statistics_module.i
                      Compact.i Compact_doc.i.in
                      Full.i Full_doc.i.in
                      Last.i Last_doc.i.in
                      Null.i Null_doc.i.in
                      TestResult.i TestResult_doc.i.in
                      RandomGenerator.i RandomGenerator_doc.i.in
                      RandomGeneratorState.i RandomGeneratorState_doc.i.in
                      LowDiscrepancySequenceImplementation.i LowDiscrepancySequenceImplementation_doc.i.in
                      LowDiscrepancySequence.i LowDiscrepancySequence_doc.i.in
                      SobolSequence.i SobolSequence_doc.i.in
                      FaureSequence.i FaureSequence_doc.i.in
                      HaltonSequence.i HaltonSequence_doc.i.in
                      HaselgroveSequence.i HaselgroveSequence_doc.i.in
                      ReverseHaltonSequence.i ReverseHaltonSequence_doc.i.in
                      SphericalModel.i SphericalModel_doc.i.in
                      FilteringWindowsImplementation.i FilteringWindowsImplementation_doc.i.in
                      FilteringWindows.i FilteringWindows_doc.i.in
                      Hamming.i Hamming_doc.i.in
                      Hann.i Hann_doc.i.in
                      FFTImplementation.i FFTImplementation_doc.i.in
                      FFT.i FFT_doc.i.in
                      SpectralModelImplementation.i SpectralModelImplementation_doc.i.in
                      SpectralModel.i SpectralModel_doc.i.in
                      CovarianceModelImplementation.i CovarianceModelImplementation_doc.i.in
                      CovarianceModel.i CovarianceModel_doc.i.in
                      StationaryFunctionalCovarianceModel.i StationaryFunctionalCovarianceModel_doc.i.in
                      SpectralModelFactoryImplementation.i SpectralModelFactoryImplementation_doc.i.in
                      SpectralModelFactory.i SpectralModelFactory_doc.i.in
                      UserDefinedSpectralModel.i UserDefinedSpectralModel_doc.i.in
                      WelchFactory.i WelchFactory_doc.i.in
                      KroneckerCovarianceModel.i KroneckerCovarianceModel_doc.i.in
                      ExponentialModel.i ExponentialModel_doc.i.in
                      ExponentiallyDampedCosineModel.i ExponentiallyDampedCosineModel_doc.i.in
                      CauchyModel.i CauchyModel_doc.i.in
                      CovarianceModelFactoryImplementation.i CovarianceModelFactoryImplementation_doc.i.in
                      CovarianceModelFactory.i CovarianceModelFactory_doc.i.in
                      UserDefinedCovarianceModel.i UserDefinedCovarianceModel_doc.i.in
                      UserDefinedStationaryCovarianceModel.i UserDefinedStationaryCovarianceModel_doc.i.in
                      StationaryCovarianceModelFactory.i StationaryCovarianceModelFactory_doc.i.in
                      NonStationaryCovarianceModelFactory.i NonStationaryCovarianceModelFactory_doc.i.in
                      SquaredExponential.i SquaredExponential_doc.i.in
                      GeneralizedExponential.i GeneralizedExponential_doc.i.in

=== python/test/CMakeLists.txt ===
#                                               -*- cmake -*-

set (PYINSTALLCHECK_ENVIRONMENT "OPENTURNS_CONFIG_PATH=${INSTALL_DESTDIR}${SYSCONFIG_PATH}/openturns"
                                 "PYTHONPATH=${INSTALL_DESTDIR}${PYTHON_MODULE_PATH}${PATH_SEP}$ENV{PYTHONPATH}" "MPLBACKEND=agg"
   )

# This macro compiles on the fly and run the corresponding post-installation test
# It can have two optional arguments PRE and POST followed by some shell command to be run
# before or after the test if needed
# PRE and POST options cn be repeated many times: the arguments will be run one after the other
# in the order of appearence. If one fails, the whole command fails.
macro (ot_pyinstallcheck_test TESTNAME)
  set (TESTNAME_TGT t_${TESTNAME})
  set (TESTNAME_SRC ${TESTNAME_TGT}.py)
  set (TESTNAME_LOC ${CMAKE_CURRENT_SOURCE_DIR}/${TESTNAME_SRC})
  set (_CMD)
  set (_PARAMS)
  set (_IGNOREOUT OFF)
  foreach (_ARG ${ARGN})
    string (TOUPPER ${_ARG} ARG)
    if (${ARG} MATCHES PARAMS)
      set (_CMD PARAMS)
    elseif (${ARG} MATCHES IGNOREOUT)
      set (_IGNOREOUT ON)
    else ()
      if (${_CMD} MATCHES PARAMS)
        set (_PARAMS "${_PARAMS} ${_ARG}")
      endif ()
      set (_CMD)
    endif ()
  endforeach ()

  if (_IGNOREOUT)
    set (COMMAND "(${PYTHON_EXECUTABLE} ${TESTNAME_LOC} ${_PARAMS} > /dev/null)")
  else (_IGNOREOUT)
    set (TESTNAME_OUT ${TESTNAME_TGT}.expout)
    get_source_file_property (OUTFILE_LOC ${TESTNAME_OUT} LOCATION)
    set (OUTFILE_LOC ${CMAKE_CURRENT_SOURCE_DIR}/${TESTNAME_OUT})
    set (COMMAND "(${PYTHON_EXECUTABLE} ${TESTNAME_LOC} ${_PARAMS} > ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out) && diff -u --strip-trailing-cr ${OUTFILE_LOC} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out")
  endif ()

  add_test (pyinstallcheck_${TESTNAME} "sh" "-c" "${COMMAND}")
  set_tests_properties (pyinstallcheck_${TESTNAME} PROPERTIES ENVIRONMENT "${PYINSTALLCHECK_ENVIRONMENT}")
endmacro ()


## Python post-installation tests

# Use cases
ot_pyinstallcheck_test (ackley_function IGNOREOUT)
ot_pyinstallcheck_test (branin_function IGNOREOUT)
ot_pyinstallcheck_test (cantilever_beam IGNOREOUT)
ot_pyinstallcheck_test (chaboche_model IGNOREOUT)
ot_pyinstallcheck_test (deflection_tube IGNOREOUT)
ot_pyinstallcheck_test (flood_model IGNOREOUT)
ot_pyinstallcheck_test (ishigami_function IGNOREOUT)
ot_pyinstallcheck_test (logistic_model IGNOREOUT)
ot_pyinstallcheck_test (stressed_beam IGNOREOUT)
ot_pyinstallcheck_test (fireSatellite_function IGNOREOUT)
ot_pyinstallcheck_test (wingweight_function IGNOREOUT)
if (NUMPY_FOUND)
  ot_pyinstallcheck_test (viscous_free_fall IGNOREOUT)
endif()

# Common
if (LIBXML2_FOUND)
  ot_pyinstallcheck_test (Object_pickle)
endif ()
ot_pyinstallcheck_test (ComparisonOperator_std)
if (LIBXML2_FOUND)
  ot_pyinstallcheck_test (Study_saveload)
  ot_pyinstallcheck_test (Study_std IGNOREOUT)
  if (HDF5_FOUND)
    ot_pyinstallcheck_test (Study_h5 IGNOREOUT)
  endif ()
endif ()
ot_pyinstallcheck_test (Path_std IGNOREOUT)
ot_pyinstallcheck_test (ResourceMap_std IGNOREOUT)
ot_pyinstallcheck_test (Catalog_std IGNOREOUT)

# Type
ot_pyinstallcheck_test (Collection_std)
ot_pyinstallcheck_test (Description_std)
ot_pyinstallcheck_test (Indices_std)
ot_pyinstallcheck_test (IndicesCollection_std)
ot_pyinstallcheck_test (Point_std)
ot_pyinstallcheck_test (Point_description)
ot_pyinstallcheck_test (Matrix_std)
ot_pyinstallcheck_test (SymmetricMatrix_lapack)
ot_pyinstallcheck_test (SquareMatrix_lapack)
ot_pyinstallcheck_test (SquareMatrix_std)
ot_pyinstallcheck_test (TriangularMatrix_std)
ot_pyinstallcheck_test (SymmetricMatrix_std)
ot_pyinstallcheck_test (Tensor_std)
ot_pyinstallcheck_test (ComplexTensor_std)
ot_pyinstallcheck_test (SymmetricTensor_std)
ot_pyinstallcheck_test (Matrix_solve)
ot_pyinstallcheck_test (Matrix_decomposition)
ot_pyinstallcheck_test (IdentityMatrix_std)
ot_pyinstallcheck_test (RegularGrid_std)
ot_pyinstallcheck_test (ComplexMatrix_std)
ot_pyinstallcheck_test (SquareComplexMatrix_std)
ot_pyinstallcheck_test (HermitianMatrix_std)
ot_pyinstallcheck_test (TriangularComplexMatrix_std)
ot_pyinstallcheck_test (Matrix_slice)
ot_pyinstallcheck_test (Matrix_operators)
if (NUMPY_FOUND)
  ot_pyinstallcheck_test (Matrix_numpy)
endif ()

# Func
ot_pyinstallcheck_test (SpecFunc_std)
ot_pyinstallcheck_test (Function_std)
ot_pyinstallcheck_test (Function_linearity IGNOREOUT)
ot_pyinstallcheck_test (ComposedFunction_std)
ot_pyinstallcheck_test (Function_python)
if (LIBXML2_FOUND)
ot_pyinstallcheck_test (Function_python_saveload)
endif ()
ot_pyinstallcheck_test (DatabaseFunction_std)
ot_pyinstallcheck_test (Function_operations)
ot_pyinstallcheck_test (ParametricFunction_std)

ot_pyinstallcheck_test (Function_draw)
ot_pyinstallcheck_test (MemoizeFunction_std)
ot_pyinstallcheck_test (AggregatedEvaluation_std)
if (OPENTURNS_HAVE_EXPRTK)
ot_pyinstallcheck_test (SymbolicEvaluation_std)
ot_pyinstallcheck_test (SymbolicGradient_std)
ot_pyinstallcheck_test (SymbolicHessian_std)
ot_pyinstallcheck_test (SymbolicFunction_std)
endif ()
if (OPENTURNS_HAVE_MUPARSER)
ot_pyinstallcheck_test (SymbolicEvaluation_muparser)
ot_pyinstallcheck_test (SymbolicGradient_muparser)
ot_pyinstallcheck_test (SymbolicHessian_muparser)
ot_pyinstallcheck_test (SymbolicFunction_muparser)
endif ()
ot_pyinstallcheck_test (TranslationFunction_std)
ot_pyinstallcheck_test (LinearFunction_std)
ot_pyinstallcheck_test (LinearEvaluation_std)
ot_pyinstallcheck_test (LinearCombinationEvaluation_std)
ot_pyinstallcheck_test (LinearCombinationGradient_std)
ot_pyinstallcheck_test (LinearCombinationHessian_std)
ot_pyinstallcheck_test (PiecewiseLinearEvaluation_std)
ot_pyinstallcheck_test (PiecewiseHermiteEvaluation_std)
ot_pyinstallcheck_test (QuadraticFunction_std)
ot_pyinstallcheck_test (QuadraticEvaluation_std)
ot_pyinstallcheck_test (LinearGradient_std)
ot_pyinstallcheck_test (AggregatedFunction_std)
ot_pyinstallcheck_test (DualLinearCombinationFunction_std)
ot_pyinstallcheck_test (IndicatorFunction_std IGNOREOUT)
ot_pyinstallcheck_test (DistanceToDomainFunction_std IGNOREOUT)
ot_pyinstallcheck_test (LinearCombinationFunction_std)
ot_pyinstallcheck_test (ConstantGradient_std)
ot_pyinstallcheck_test (ConstantHessian_std)
ot_pyinstallcheck_test (Basis_std)
ot_pyinstallcheck_test (BasisSequence_std)
ot_pyinstallcheck_test (LARS_std)
ot_pyinstallcheck_test (FieldFunction_std)
ot_pyinstallcheck_test (FieldFunction_python)
ot_pyinstallcheck_test (ValueFunction_std)
ot_pyinstallcheck_test (VertexValueFunction_std)
ot_pyinstallcheck_test (FieldToPointFunction_std)
ot_pyinstallcheck_test (FieldToPointFunction_python)
ot_pyinstallcheck_test (PointToFieldFunction_std)
ot_pyinstallcheck_test (PointToFieldFunction_python)
if (LIBXML2_FOUND AND DILL_FOUND)
  ot_pyinstallcheck_test (PythonPointToFieldFunction_save IGNOREOUT)
  ot_pyinstallcheck_test (PythonPointToFieldFunction_load IGNOREOUT)
  set_tests_properties(pyinstallcheck_PythonPointToFieldFunction_load
    PROPERTIES DEPENDS pyinstallcheck_PythonPointToFieldFunction_save)
endif ()
ot_pyinstallcheck_test (ParametricPointToFieldFunction_std)
ot_pyinstallcheck_test (VertexValuePointToFieldFunction_std)
ot_pyinstallcheck_test (BoxCoxEvaluation_std)
ot_pyinstallcheck_test (BoxCoxTransform_std)
ot_pyinstallcheck_test (InverseBoxCoxEvaluation_std)
ot_pyinstallcheck_test (InverseBoxCoxTransform_std)
ot_pyinstallcheck_test (TrendEvaluation_std)
ot_pyinstallcheck_test (TrendTransform_std)
ot_pyinstallcheck_test (InverseTrendEvaluation_std)
ot_pyinstallcheck_test (InverseTrendTransform_std)
ot_pyinstallcheck_test (ExpertMixture_std)
ot_pyinstallcheck_test (UniVariatePolynomial_std)
ot_pyinstallcheck_test (BasisFactory_std)
ot_pyinstallcheck_test (Field_std)
ot_pyinstallcheck_test (MonomialFunction_std)
ot_pyinstallcheck_test (MonomialFunctionFactory_std)
ot_pyinstallcheck_test (TensorizedUniVariateFunctionFactory_std)
ot_pyinstallcheck_test (PointToPointEvaluation_std)
ot_pyinstallcheck_test (PointToPointConnection_std)
ot_pyinstallcheck_test (PointToFieldConnection_std)
ot_pyinstallcheck_test (FieldToPointConnection_std)
ot_pyinstallcheck_test (FieldToFieldConnection_std)
if (NOT MINGW)
  ot_pyinstallcheck_test (PythonFunction_multiprocessing IGNOREOUT)
endif ()
if (LIBXML2_FOUND AND DILL_FOUND)
  ot_pyinstallcheck_test (PythonFunction_save IGNOREOUT)
  ot_pyinstallcheck_test (PythonFunction_load IGNOREOUT)
  set_tests_properties(pyinstallcheck_PythonFunction_load
    PROPERTIES DEPENDS pyinstallcheck_PythonFunction_save)
endif ()

# Stat
ot_pyinstallcheck_test (Sample_std)
ot_pyinstallcheck_test (Sample_computation)
ot_pyinstallcheck_test (Sample_slice)
ot_pyinstallcheck_test (Sample_split)
ot_pyinstallcheck_test (Sample_large)
ot_pyinstallcheck_test (Sample_bug14)
if (BISON_FOUND AND FLEX_FOUND)
ot_pyinstallcheck_test (Sample_csv)
endif ()
if (OPENTURNS_HAVE_FR_LOC)
  ot_pyinstallcheck_test (Sample_csv_fr)
endif ()
ot_pyinstallcheck_test (Sample_operators)
if (PANDAS_FOUND)
  ot_pyinstallcheck_test (Sample_pandas IGNOREOUT)
endif ()
ot_pyinstallcheck_test (HistoryStrategy_std)
ot_pyinstallcheck_test (CovarianceMatrix_std)
ot_pyinstallcheck_test (CorrelationMatrix_std)
ot_pyinstallcheck_test (CorrelationAnalysis_std IGNOREOUT)
ot_pyinstallcheck_test (Field_draw)
ot_pyinstallcheck_test (ProcessSample_std)
ot_pyinstallcheck_test (RandomGenerator_std)
ot_pyinstallcheck_test (SobolSequence_std)
ot_pyinstallcheck_test (FaureSequence_std)
ot_pyinstallcheck_test (HaltonSequence_std)
ot_pyinstallcheck_test (HaselgroveSequence_std)
ot_pyinstallcheck_test (ReverseHaltonSequence_std)
ot_pyinstallcheck_test (TestResult_std)
ot_pyinstallcheck_test (TimeSeries_std)
ot_pyinstallcheck_test (FilteringWindows_std)
ot_pyinstallcheck_test (WelchFactory_std)
ot_pyinstallcheck_test (ExponentialModel_std)
ot_pyinstallcheck_test (CovarianceModel_std IGNOREOUT)
ot_pyinstallcheck_test (ExponentiallyDampedCosineModel_std)
ot_pyinstallcheck_test (CauchyModel_std)
ot_pyinstallcheck_test (UserDefinedSpectralModel_std)
ot_pyinstallcheck_test (UserDefinedCovarianceModel_std)
ot_pyinstallcheck_test (UserDefinedStationaryCovarianceModel_std)
ot_pyinstallcheck_test (StationaryCovarianceModelFactory_std)
ot_pyinstallcheck_test (NonStationaryCovarianceModelFactory_std)
ot_pyinstallcheck_test (ProductCovarianceModel_std)
ot_pyinstallcheck_test (StationaryFunctionalCovarianceModel_std IGNOREOUT)

if (HMAT_FOUND)
ot_pyinstallcheck_test (HMatrix_std)
endif ()

# Geom
ot_pyinstallcheck_test (Domain_std)
ot_pyinstallcheck_test (Interval_std)
ot_pyinstallcheck_test (IntervalMesher_std)
ot_pyinstallcheck_test (LevelSet_std)
ot_pyinstallcheck_test (LevelSetMesher_std)
ot_pyinstallcheck_test (Mesh_std)
ot_pyinstallcheck_test (Mesh_draw IGNOREOUT)
ot_pyinstallcheck_test (DomainComplement_std)
ot_pyinstallcheck_test (DomainDifference_std)
ot_pyinstallcheck_test (DomainIntersection_std)
ot_pyinstallcheck_test (DomainUnion_std)
ot_pyinstallcheck_test (DomainDisjunctiveUnion_std)

## Graph
ot_pyinstallcheck_test (BarPlot_std)
ot_pyinstallcheck_test (Cloud_std)
ot_pyinstallcheck_test (Contour_std)
ot_pyinstallcheck_test (Curve_std)
ot_pyinstallcheck_test (Drawable_std)
ot_pyinstallcheck_test (Graph_mix)
ot_pyinstallcheck_test (Pie_std)
ot_pyinstallcheck_test (Polygon_std)
ot_pyinstallcheck_test (PolygonArray_std)
ot_pyinstallcheck_test (Staircase_std)
ot_pyinstallcheck_test (Text_std)
ot_pyinstallcheck_test (GridLayout_std IGNOREOUT)

## Diff
ot_pyinstallcheck_test (FiniteDifferenceStep_std)
ot_pyinstallcheck_test (CenteredFiniteDifferenceGradient_std)
ot_pyinstallcheck_test (CenteredFiniteDifferenceHessian_std)
ot_pyinstallcheck_test (NonCenteredFiniteDifferenceGradient_std)

## Optim
ot_pyinstallcheck_test (AbdoRackwitz_std)
if (Bonmin_FOUND)
  ot_pyinstallcheck_test (Bonmin_std IGNOREOUT)
  ot_pyinstallcheck_test (Bonmin_4dsoo IGNOREOUT)
  ot_pyinstallcheck_test (Bonmin_MIT15 IGNOREOUT)
  ot_pyinstallcheck_test (Bonmin_swiler2014 IGNOREOUT)
endif ()
if (Ipopt_FOUND)

=== lib/src/Base/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()
ot_install_header_file (OTBase.hxx)

# Recurse in subdirectories
add_subdirectory (Algo)
add_subdirectory (Common)
add_subdirectory (Diff)
add_subdirectory (Experiments)
add_subdirectory (Func)
add_subdirectory (Geom)
add_subdirectory (Graph)
add_subdirectory (MetaModel)
add_subdirectory (Optim)
add_subdirectory (Solver)
add_subdirectory (Stat)
add_subdirectory (Type)
add_subdirectory (IterativeStat)

=== lib/src/Base/Common/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()

ot_add_source_file (OSS.cxx)
ot_add_source_file (PlatformInfo.cxx)
ot_add_source_file (Object.cxx)
ot_add_source_file (PersistentObject.cxx)
ot_add_source_file (IdFactory.cxx)
ot_add_source_file (Catalog.cxx)
ot_add_source_file (Exception.cxx)
ot_add_source_file (InterfaceObject.cxx)
ot_add_source_file (StorageManager.cxx)
ot_add_source_file (Os.cxx)
ot_add_source_file (Path.cxx)
ot_add_source_file (ComparisonOperator.cxx)
ot_add_source_file (ComparisonOperatorImplementation.cxx)
ot_add_source_file (OStream.cxx)
ot_add_source_file (Less.cxx)
ot_add_source_file (LessOrEqual.cxx)
ot_add_source_file (Equal.cxx)
ot_add_source_file (Greater.cxx)
ot_add_source_file (GreaterOrEqual.cxx)
ot_add_source_file (ResourceMap.cxx)
ot_add_source_file (Log.cxx)
ot_add_source_file (TTY.cxx)
ot_add_source_file (TBB.cxx)
ot_add_source_file (TBBImplementation.cxx)
ot_add_source_file (Study.cxx)

if (LIBXML2_FOUND)
  ot_add_source_file (XMLStorageManager.cxx)
  ot_add_source_file (XMLToolbox.cxx)
  if (HDF5_FOUND)
    ot_add_source_file (XMLH5StorageManager.cxx)
  endif ()
endif ()

ot_install_header_file (Greater.hxx)
ot_install_header_file (ResourceMap.hxx)
ot_install_header_file (ComparisonOperatorImplementation.hxx)
ot_install_header_file (OStream.hxx)
ot_install_header_file (StorageManager.hxx)
ot_install_header_file (OSS.hxx)
ot_install_header_file (Study.hxx)
ot_install_header_file (Less.hxx)
ot_install_header_file (PersistentObject.hxx)
ot_install_header_file (PlatformInfo.hxx)
ot_install_header_file (AtomicInt.hxx)
ot_install_header_file (MutexLock.hxx)
ot_install_header_file (Equal.hxx)
ot_install_header_file (Pointer.hxx)
ot_install_header_file (IdFactory.hxx)
ot_install_header_file (PersistentObjectFactory.hxx)
ot_install_header_file (ComparisonOperator.hxx)
ot_install_header_file (TypedInterfaceObject.hxx)
ot_install_header_file (InterfaceObject.hxx)
ot_install_header_file (OTCommon.hxx)
ot_install_header_file (Catalog.hxx)
ot_install_header_file (GreaterOrEqual.hxx)
ot_install_header_file (Log.hxx)
ot_install_header_file (TBB.hxx)
ot_install_header_file (TBBImplementation.hxx)
ot_install_header_file (TypedCollectionInterfaceObject.hxx)
ot_install_header_file (Os.hxx)
ot_install_header_file (Object.hxx)
ot_install_header_file (LessOrEqual.hxx)
ot_install_header_file (Exception.hxx)
ot_install_header_file (Path.hxx)
ot_install_header_file (TTY.hxx)

if (LIBXML2_FOUND)
  ot_install_header_file (XMLStorageManager.hxx)
  ot_install_header_file (XMLToolbox.hxx)
  if (HDF5_FOUND)
    ot_install_header_file (XMLH5StorageManager.hxx)
  endif ()
endif ()

=== lib/src/Base/Func/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()

ot_add_source_file (AggregatedFunction.cxx)
ot_add_source_file (AggregatedGradient.cxx)
ot_add_source_file (AggregatedHessian.cxx)
ot_add_source_file (AggregatedEvaluation.cxx)
ot_add_source_file (BasisImplementation.cxx)
ot_add_source_file (Basis.cxx)
ot_add_source_file (BasisFactory.cxx)
ot_add_source_file (BasisSequenceImplementation.cxx)
ot_add_source_file (BasisSequence.cxx)
ot_add_source_file (BasisSequenceFactoryImplementation.cxx)
ot_add_source_file (BasisSequenceFactory.cxx)
ot_add_source_file (BoxCoxEvaluation.cxx)
ot_add_source_file (BoxCoxGradient.cxx)
ot_add_source_file (BoxCoxHessian.cxx)
ot_add_source_file (BoxCoxTransform.cxx)
ot_add_source_file (ConstantGradient.cxx)
ot_add_source_file (ConstantHessian.cxx)
ot_add_source_file (ComposedEvaluation.cxx)
ot_add_source_file (ComposedFunction.cxx)
ot_add_source_file (ComposedGradient.cxx)
ot_add_source_file (ComposedHessian.cxx)
ot_add_source_file (ConstantBasisFactory.cxx)
ot_add_source_file (DatabaseFunction.cxx)
ot_add_source_file (DatabaseEvaluation.cxx)
ot_add_source_file (DistanceToDomainEvaluation.cxx)
ot_add_source_file (DistanceToDomainFunction.cxx)
ot_add_source_file (DualLinearCombinationEvaluation.cxx)
ot_add_source_file (DualLinearCombinationFunction.cxx)
ot_add_source_file (DualLinearCombinationGradient.cxx)
ot_add_source_file (DualLinearCombinationHessian.cxx)
ot_add_source_file (EnumerateFunction.cxx)
ot_add_source_file (EnumerateFunctionImplementation.cxx)
ot_add_source_file (Evaluation.cxx)
ot_add_source_file (EvaluationImplementation.cxx)
ot_add_source_file (EvaluationProxy.cxx)
ot_add_source_file (ExpertMixture.cxx)
ot_add_source_file (FieldFunction.cxx)
ot_add_source_file (FieldFunctionImplementation.cxx)
ot_add_source_file (FieldToPointFunction.cxx)
ot_add_source_file (FieldToPointFunctionImplementation.cxx)
ot_add_source_file (FieldToFieldConnection.cxx)
ot_add_source_file (FieldToPointConnection.cxx)
ot_add_source_file (FiniteBasis.cxx)
ot_add_source_file (FourierSeries.cxx)
ot_add_source_file (Function.cxx)
ot_add_source_file (FunctionImplementation.cxx)
ot_add_source_file (GradientImplementation.cxx)
ot_add_source_file (Gradient.cxx)
ot_add_source_file (HaarWavelet.cxx)
ot_add_source_file (HessianImplementation.cxx)
ot_add_source_file (Hessian.cxx)
ot_add_source_file (HyperbolicAnisotropicEnumerateFunction.cxx)
ot_add_source_file (IdentityFunction.cxx)
ot_add_source_file (IdentityEvaluation.cxx)
ot_add_source_file (IndicatorEvaluation.cxx)
ot_add_source_file (IndicatorFunction.cxx)
ot_add_source_file (InverseBoxCoxEvaluation.cxx)
ot_add_source_file (InverseBoxCoxGradient.cxx)
ot_add_source_file (InverseBoxCoxHessian.cxx)
ot_add_source_file (InverseBoxCoxTransform.cxx)
ot_add_source_file (InverseTrendEvaluation.cxx)
ot_add_source_file (InverseTrendTransform.cxx)
ot_add_source_file (LinearBasisFactory.cxx)
ot_add_source_file (LinearCombinationEvaluation.cxx)
ot_add_source_file (LinearCombinationGradient.cxx)
ot_add_source_file (LinearCombinationHessian.cxx)
ot_add_source_file (LinearEvaluation.cxx)
ot_add_source_file (LinearFunction.cxx)
ot_add_source_file (LinearGradient.cxx)
ot_add_source_file (LinearCombinationFunction.cxx)
ot_add_source_file (LinearEnumerateFunction.cxx)
ot_add_source_file (LARS.cxx)
ot_add_source_file (MonomialFunction.cxx)
ot_add_source_file (MonomialFunctionFactory.cxx)
ot_add_source_file (MemoizeEvaluation.cxx)
ot_add_source_file (MemoizeFunction.cxx)
ot_add_source_file (NullHessian.cxx)
ot_add_source_file (MarginalEvaluation.cxx)
ot_add_source_file (MarginalGradient.cxx)
ot_add_source_file (MarginalHessian.cxx)
ot_add_source_file (NoEvaluation.cxx)
ot_add_source_file (NoGradient.cxx)
ot_add_source_file (NoHessian.cxx)
ot_add_source_file (NormInfEnumerateFunction.cxx)
ot_add_source_file (P1LagrangeEvaluation.cxx)
ot_add_source_file (P1LagrangeInterpolation.cxx)
ot_add_source_file (ParametricEvaluation.cxx)
ot_add_source_file (ParametricFunction.cxx)
ot_add_source_file (ParametricGradient.cxx)
ot_add_source_file (ParametricHessian.cxx)
ot_add_source_file (PiecewiseLinearEvaluation.cxx)
ot_add_source_file (PiecewiseHermiteEvaluation.cxx)
ot_add_source_file (PointToFieldFunction.cxx)
ot_add_source_file (PointToFieldFunctionImplementation.cxx)
ot_add_source_file (ParametricPointToFieldFunction.cxx)
ot_add_source_file (VertexValuePointToFieldFunction.cxx)
ot_add_source_file (PointToPointEvaluation.cxx)
ot_add_source_file (PointToFieldConnection.cxx)
ot_add_source_file (PointToPointConnection.cxx)
ot_add_source_file (ProductEvaluation.cxx)
ot_add_source_file (ProductFunction.cxx)
ot_add_source_file (ProductGradient.cxx)
ot_add_source_file (ProductHessian.cxx)
ot_add_source_file (ProductPolynomialEvaluation.cxx)
ot_add_source_file (ProductPolynomialHessian.cxx)
ot_add_source_file (ProductPolynomialGradient.cxx)
ot_add_source_file (ProductUniVariateFunctionEvaluation.cxx)
ot_add_source_file (ProductUniVariateFunctionGradient.cxx)
ot_add_source_file (ProductUniVariateFunctionHessian.cxx)
ot_add_source_file (QuadraticBasisFactory.cxx)
ot_add_source_file (QuadraticEvaluation.cxx)
ot_add_source_file (QuadraticFunction.cxx)
ot_add_source_file (SymbolicParserImplementation.cxx)
ot_add_source_file (SymbolicParser.cxx)
if (OPENTURNS_HAVE_MUPARSER)
ot_add_source_file (SymbolicParserMuParser.cxx)
endif ()
if (OPENTURNS_HAVE_EXPRTK)
ot_add_source_file (SymbolicParserExprTk.cxx)
endif ()
ot_add_source_file (SymbolicEvaluation.cxx)
ot_add_source_file (SymbolicFunction.cxx)
ot_add_source_file (SymbolicGradient.cxx)
ot_add_source_file (SymbolicHessian.cxx)
ot_add_source_file (TensorizedUniVariateFunctionFactory.cxx)
ot_add_source_file (TranslationFunction.cxx)
ot_add_source_file (TranslationEvaluation.cxx)
ot_add_source_file (TrendEvaluation.cxx)
ot_add_source_file (TrendTransform.cxx)
ot_add_source_file (UniVariateFunctionEvaluation.cxx)
ot_add_source_file (UniVariateFunctionFamily.cxx)
ot_add_source_file (UniVariateFunctionFactory.cxx)
ot_add_source_file (UniVariatePolynomialImplementation.cxx)
ot_add_source_file (UniVariatePolynomial.cxx)
ot_add_source_file (UniVariateFunctionImplementation.cxx)
ot_add_source_file (UniVariateFunction.cxx)
ot_add_source_file (ValueFunction.cxx)
ot_add_source_file (VertexValueFunction.cxx)

ot_install_header_file (AggregatedFunction.hxx)
ot_install_header_file (SymbolicParserImplementation.hxx)
ot_install_header_file (SymbolicParser.hxx)
# ot_install_header_file (SymbolicParserMuParser.hxx)  Internal header file
# ot_install_header_file (SymbolicParserExprTk.hxx)    Internal header file
ot_install_header_file (SymbolicEvaluation.hxx)
ot_install_header_file (SymbolicGradient.hxx)
ot_install_header_file (SymbolicHessian.hxx)
ot_install_header_file (ComposedFunction.hxx)
ot_install_header_file (DualLinearCombinationFunction.hxx)
ot_install_header_file (EnumerateFunction.hxx)
ot_install_header_file (EnumerateFunctionImplementation.hxx)
ot_install_header_file (LinearCombinationFunction.hxx)
ot_install_header_file (LinearEnumerateFunction.hxx)
ot_install_header_file (HyperbolicAnisotropicEnumerateFunction.hxx)
ot_install_header_file (NormInfEnumerateFunction.hxx)
ot_install_header_file (ParametricFunction.hxx)
ot_install_header_file (ProductPolynomialEvaluation.hxx)
ot_install_header_file (ProductPolynomialGradient.hxx)
ot_install_header_file (ProductPolynomialHessian.hxx)
ot_install_header_file (AggregatedEvaluation.hxx)
ot_install_header_file (AggregatedGradient.hxx)
ot_install_header_file (AggregatedHessian.hxx)
ot_install_header_file (PiecewiseLinearEvaluation.hxx)
ot_install_header_file (PiecewiseHermiteEvaluation.hxx)
ot_install_header_file (ConstantGradient.hxx)
ot_install_header_file (QuadraticEvaluation.hxx)
ot_install_header_file (NoGradient.hxx)
ot_install_header_file (ProductEvaluation.hxx)
ot_install_header_file (NoHessian.hxx)
ot_install_header_file (IndicatorEvaluation.hxx)
ot_install_header_file (DistanceToDomainEvaluation.hxx)
ot_install_header_file (MethodBoundEvaluation.hxx)
ot_install_header_file (ComposedHessian.hxx)
ot_install_header_file (OTFunc.hxx)
ot_install_header_file (HessianImplementation.hxx)
ot_install_header_file (Hessian.hxx)
ot_install_header_file (ProductFunction.hxx)
ot_install_header_file (TranslationEvaluation.hxx)
ot_install_header_file (LinearGradient.hxx)
ot_install_header_file (LinearEvaluation.hxx)
ot_install_header_file (IdentityEvaluation.hxx)
ot_install_header_file (NoEvaluation.hxx)
ot_install_header_file (ConstantHessian.hxx)
ot_install_header_file (TranslationFunction.hxx)
ot_install_header_file (LinearFunction.hxx)
ot_install_header_file (IdentityFunction.hxx)
ot_install_header_file (IndicatorFunction.hxx)
ot_install_header_file (DistanceToDomainFunction.hxx)
ot_install_header_file (QuadraticFunction.hxx)
ot_install_header_file (UniVariatePolynomial.hxx)
ot_install_header_file (UniVariatePolynomialImplementation.hxx)
ot_install_header_file (UniVariateFunction.hxx)
ot_install_header_file (UniVariateFunctionImplementation.hxx)
ot_install_header_file (FourierSeries.hxx)
ot_install_header_file (HaarWavelet.hxx)
ot_install_header_file (UniVariateFunctionEvaluation.hxx)
ot_install_header_file (ProductUniVariateFunctionEvaluation.hxx)
ot_install_header_file (ProductUniVariateFunctionHessian.hxx)
ot_install_header_file (ProductUniVariateFunctionGradient.hxx)
ot_install_header_file (ProductGradient.hxx)
ot_install_header_file (ComposedEvaluation.hxx)
ot_install_header_file (GradientImplementation.hxx)
ot_install_header_file (Gradient.hxx)
ot_install_header_file (EvaluationImplementation.hxx)
ot_install_header_file (Evaluation.hxx)
ot_install_header_file (ComposedGradient.hxx)
ot_install_header_file (DualLinearCombinationEvaluation.hxx)
ot_install_header_file (DualLinearCombinationGradient.hxx)
ot_install_header_file (DualLinearCombinationHessian.hxx)
ot_install_header_file (ExpertMixture.hxx)
ot_install_header_file (LinearCombinationEvaluation.hxx)
ot_install_header_file (LinearCombinationGradient.hxx)
ot_install_header_file (LinearCombinationHessian.hxx)
ot_install_header_file (FunctionImplementation.hxx)
ot_install_header_file (Function.hxx)
ot_install_header_file (FieldFunction.hxx)
ot_install_header_file (FieldFunctionImplementation.hxx)
ot_install_header_file (FieldToPointFunction.hxx)
ot_install_header_file (FieldToPointFunctionImplementation.hxx)
ot_install_header_file (PointToFieldFunction.hxx)
ot_install_header_file (PointToFieldFunctionImplementation.hxx)
ot_install_header_file (ParametricPointToFieldFunction.hxx)
ot_install_header_file (VertexValuePointToFieldFunction.hxx)
ot_install_header_file (PointToPointEvaluation.hxx)
ot_install_header_file (FieldToFieldConnection.hxx)
ot_install_header_file (FieldToPointConnection.hxx)
ot_install_header_file (PointToFieldConnection.hxx)
ot_install_header_file (PointToPointConnection.hxx)
ot_install_header_file (ValueFunction.hxx)
ot_install_header_file (SymbolicFunction.hxx)
ot_install_header_file (VertexValueFunction.hxx)
ot_install_header_file (ProductHessian.hxx)
ot_install_header_file (DatabaseFunction.hxx)
ot_install_header_file (DatabaseEvaluation.hxx)
ot_install_header_file (BasisImplementation.hxx)
ot_install_header_file (Basis.hxx)
ot_install_header_file (FiniteBasis.hxx)
ot_install_header_file (BasisSequenceImplementation.hxx)
ot_install_header_file (BasisSequence.hxx)
ot_install_header_file (BasisSequenceFactoryImplementation.hxx)
ot_install_header_file (BasisSequenceFactory.hxx)
ot_install_header_file (LARS.hxx)
ot_install_header_file (BoxCoxEvaluation.hxx)
ot_install_header_file (BoxCoxGradient.hxx)
ot_install_header_file (BoxCoxHessian.hxx)
ot_install_header_file (BoxCoxTransform.hxx)
ot_install_header_file (InverseBoxCoxEvaluation.hxx)
ot_install_header_file (InverseBoxCoxGradient.hxx)
ot_install_header_file (InverseBoxCoxHessian.hxx)
ot_install_header_file (InverseBoxCoxTransform.hxx)

=== lib/src/Base/Graph/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()

ot_add_source_file (Drawable.cxx)
ot_add_source_file (DrawableImplementation.cxx)
ot_add_source_file (Contour.cxx)
ot_add_source_file (Curve.cxx)
ot_add_source_file (Cloud.cxx)
ot_add_source_file (Staircase.cxx)
ot_add_source_file (BarPlot.cxx)
ot_add_source_file (Pie.cxx)
ot_add_source_file (Polygon.cxx)
ot_add_source_file (PolygonArray.cxx)
ot_add_source_file (Text.cxx)
ot_add_source_file (Graph.cxx)
ot_add_source_file (GraphImplementation.cxx)
ot_add_source_file (GridLayout.cxx)

ot_install_header_file (Contour.hxx)
ot_install_header_file (OTGraph.hxx)
ot_install_header_file (DrawableImplementation.hxx)
ot_install_header_file (Cloud.hxx)
ot_install_header_file (Drawable.hxx)
ot_install_header_file (BarPlot.hxx)
ot_install_header_file (GraphImplementation.hxx)
ot_install_header_file (Pie.hxx)
ot_install_header_file (Polygon.hxx)
ot_install_header_file (PolygonArray.hxx)
ot_install_header_file (Staircase.hxx)
ot_install_header_file (Text.hxx)
ot_install_header_file (Rfunctions.hxx)
ot_install_header_file (Curve.hxx)
ot_install_header_file (Graph.hxx)
ot_install_header_file (GridLayout.hxx)

=== lib/src/Base/Stat/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()

ot_add_source_file (Compact.cxx)
ot_add_source_file (CorrelationAnalysis.cxx)
ot_add_source_file (CorrelationMatrix.cxx)
ot_add_source_file (CovarianceMatrix.cxx)
ot_add_source_file (FaureSequence.cxx)
ot_add_source_file (Full.cxx)
ot_add_source_file (HaltonSequence.cxx)
ot_add_source_file (HaselgroveSequence.cxx)
ot_add_source_file (HistoryStrategy.cxx)
ot_add_source_file (HistoryStrategyImplementation.cxx)
ot_add_source_file (HMatrixFactory.cxx)
ot_add_source_file (HMatrix.cxx)
ot_add_source_file (HMatrixImplementation.cxx)
ot_add_source_file (KroneckerCovarianceModel.cxx)
ot_add_source_file (Last.cxx)
ot_add_source_file (LowDiscrepancySequence.cxx)
ot_add_source_file (LowDiscrepancySequenceImplementation.cxx)
ot_add_source_file (Null.cxx)
ot_add_source_file (Sample.cxx)
ot_add_source_file (SampleImplementation.cxx)
ot_add_source_file (ProcessSample.cxx)
ot_add_source_file (ProcessSampleImplementation.cxx)
ot_add_source_file (RandomGenerator.cxx)
ot_add_source_file (RandomGeneratorState.cxx)
ot_add_source_file (ReverseHaltonSequence.cxx)
ot_add_source_file (SobolSequence.cxx)
ot_add_source_file (TestResult.cxx)
ot_add_source_file (Field.cxx)
ot_add_source_file (FieldImplementation.cxx)
ot_add_source_file (TimeSeries.cxx)
ot_add_source_file (dsfmt.cxx)
ot_add_source_file (FilteringWindowsImplementation.cxx)
ot_add_source_file (FilteringWindows.cxx)
ot_add_source_file (Hamming.cxx)
ot_add_source_file (Hann.cxx)
ot_add_source_file (CovarianceModelImplementation.cxx)
ot_add_source_file (SpectralModelImplementation.cxx)
ot_add_source_file (SpectralModel.cxx)
ot_add_source_file (CovarianceModel.cxx)
ot_add_source_file (SpectralModelFactoryImplementation.cxx)
ot_add_source_file (SpectralModelFactory.cxx)
ot_add_source_file (UserDefinedSpectralModel.cxx)
ot_add_source_file (WelchFactory.cxx)
ot_add_source_file (ExponentialModel.cxx)
ot_add_source_file (ExponentiallyDampedCosineModel.cxx)
ot_add_source_file (SphericalModel.cxx)
ot_add_source_file (CauchyModel.cxx)
ot_add_source_file (SquaredExponential.cxx)
ot_add_source_file (GeneralizedExponential.cxx)
ot_add_source_file (AbsoluteExponential.cxx)
ot_add_source_file (StationaryFunctionalCovarianceModel.cxx)
ot_add_source_file (FractionalBrownianMotionModel.cxx)
ot_add_source_file (MaternModel.cxx)
ot_add_source_file (DiracCovarianceModel.cxx)
ot_add_source_file (HMatrixParameters.cxx)
ot_add_source_file (ProductCovarianceModel.cxx)
ot_add_source_file (RankMCovarianceModel.cxx)
ot_add_source_file (TensorizedCovarianceModel.cxx)
ot_add_source_file (CovarianceModelFactoryImplementation.cxx)
ot_add_source_file (CovarianceModelFactory.cxx)
ot_add_source_file (UserDefinedCovarianceModel.cxx)
ot_add_source_file (NonStationaryCovarianceModelFactory.cxx)
ot_add_source_file (UserDefinedStationaryCovarianceModel.cxx)
ot_add_source_file (StationaryCovarianceModelFactory.cxx)
ot_add_source_file (kendall.c)
ot_add_source_file (IsotropicCovarianceModel.cxx)

ot_install_header_file (HistoryStrategyImplementation.hxx)
ot_install_header_file (SobolSequence.hxx)
ot_install_header_file (CovarianceMatrix.hxx)
ot_install_header_file (TestResult.hxx)
ot_install_header_file (FaureSequence.hxx)
ot_install_header_file (HaltonSequence.hxx)
ot_install_header_file (HaselgroveSequence.hxx)
ot_install_header_file (ReverseHaltonSequence.hxx)
ot_install_header_file (CorrelationMatrix.hxx)
ot_install_header_file (HMatrixFactory.hxx)
ot_install_header_file (HMatrix.hxx)
ot_install_header_file (HMatrixImplementation.hxx)
ot_install_header_file (KroneckerCovarianceModel.hxx)
ot_install_header_file (Last.hxx)
ot_install_header_file (RandomGenerator.hxx)
ot_install_header_file (RandomGeneratorState.hxx)
ot_install_header_file (csv_parser_state.hxx)
ot_install_header_file (HistoryStrategy.hxx)
ot_install_header_file (CorrelationAnalysis.hxx)
ot_install_header_file (LowDiscrepancySequence.hxx)
ot_install_header_file (Full.hxx)
ot_install_header_file (SampleImplementation.hxx)
ot_install_header_file (Sample.hxx)
ot_install_header_file (ProcessSample.hxx)
ot_install_header_file (ProcessSampleImplementation.hxx)
ot_install_header_file (OTStat.hxx)
ot_install_header_file (Compact.hxx)
ot_install_header_file (LowDiscrepancySequenceImplementation.hxx)
ot_install_header_file (Null.hxx)
ot_install_header_file (Field.hxx)
ot_install_header_file (FieldImplementation.hxx)
ot_install_header_file (TimeSeries.hxx)
ot_install_header_file (FilteringWindowsImplementation.hxx)
ot_install_header_file (FilteringWindows.hxx)
ot_install_header_file (Hamming.hxx)
ot_install_header_file (Hann.hxx)
ot_install_header_file (CovarianceModelImplementation.hxx)
ot_install_header_file (SpectralModelImplementation.hxx)
ot_install_header_file (SpectralModel.hxx)
ot_install_header_file (CovarianceModel.hxx)
ot_install_header_file (SpectralModelFactoryImplementation.hxx)
ot_install_header_file (SpectralModelFactory.hxx)
ot_install_header_file (UserDefinedSpectralModel.hxx)
ot_install_header_file (WelchFactory.hxx)
ot_install_header_file (ExponentialModel.hxx)
ot_install_header_file (ExponentiallyDampedCosineModel.hxx)
ot_install_header_file (SphericalModel.hxx)
ot_install_header_file (CauchyModel.hxx)
ot_install_header_file (CovarianceModelFactoryImplementation.hxx)
ot_install_header_file (CovarianceModelFactory.hxx)
ot_install_header_file (UserDefinedCovarianceModel.hxx)
ot_install_header_file (NonStationaryCovarianceModelFactory.hxx)
ot_install_header_file (UserDefinedStationaryCovarianceModel.hxx)
ot_install_header_file (StationaryCovarianceModelFactory.hxx)
ot_install_header_file (SquaredExponential.hxx)
ot_install_header_file (GeneralizedExponential.hxx)
ot_install_header_file (AbsoluteExponential.hxx)
ot_install_header_file (StationaryFunctionalCovarianceModel.hxx)
ot_install_header_file (FractionalBrownianMotionModel.hxx)
ot_install_header_file (MaternModel.hxx)
ot_install_header_file (DiracCovarianceModel.hxx)
ot_install_header_file (HMatrixParameters.hxx)
ot_install_header_file (ProductCovarianceModel.hxx)
ot_install_header_file (RankMCovarianceModel.hxx)
ot_install_header_file (TensorizedCovarianceModel.hxx)
ot_install_header_file (IsotropicCovarianceModel.hxx)

# Build on the fly source files
if (BISON_FOUND AND FLEX_FOUND)
  ot_add_build_dir_to_include_dirs (${CMAKE_CURRENT_BINARY_DIR})
  set (BISON_FLAGS "-Wno-deprecated" CACHE STRING "bison flags")
  separate_arguments(BISON_FLAGS)
  add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/csv_parser.cc ${CMAKE_CURRENT_BINARY_DIR}/csv_parser.hh
                      MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/csv_parser.yy
                      COMMAND ${BISON_EXECUTABLE}
                      ARGS    ${BISON_FLAGS}
                              -o ${CMAKE_CURRENT_BINARY_DIR}/csv_parser.cc
                                 ${CMAKE_CURRENT_SOURCE_DIR}/csv_parser.yy
                      COMMENT "CSV parser generation"
                   )
  ot_add_built_source_file (${CMAKE_CURRENT_BINARY_DIR}/csv_parser.cc)
  add_custom_target (generate_csv_parser DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/csv_parser.cc)

  add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/csv_lexer.cc ${CMAKE_CURRENT_BINARY_DIR}/csv_lexer.h
                      MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/csv_lexer.ll
                      COMMAND ${FLEX_EXECUTABLE}
                      ARGS    -o ${CMAKE_CURRENT_BINARY_DIR}/csv_lexer.cc
                              --header-file=${CMAKE_CURRENT_BINARY_DIR}/csv_lexer.h
                              ${CMAKE_CURRENT_SOURCE_DIR}/csv_lexer.ll
                      COMMENT "CSV lexer generation"
                   )
  ot_add_built_source_file (${CMAKE_CURRENT_BINARY_DIR}/csv_lexer.cc)
  add_custom_target (generate_csv_lexer DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/csv_lexer.cc)
endif ()

=== debian/changelog ===
openturns (1.20-9) unstable; urgency=medium

  * Removing an obsolete Lintian override

 -- Pierre Gruet <pgt@debian.org>  Mon, 30 Jan 2023 13:15:01 +0100

openturns (1.20-9~exp0) experimental; urgency=medium

  * Build-depending on coinor-libbonmin-dev

 -- Pierre Gruet <pgt@debian.org>  Sat, 14 Jan 2023 07:24:03 +0100

openturns (1.20-8) unstable; urgency=medium

  * Ignoring the comparison of the output of
    pyinstallcheck_StandardDistributionPolynomialFactory_std due to
    rounding errors

 -- Pierre Gruet <pgt@debian.org>  Sat, 17 Dec 2022 15:17:52 +0100

openturns (1.20-7) unstable; urgency=medium

  * Ignoring the comparison of the output of
    cppcheck_StandardDistributionPolynomialFactory_std due to rounding errors

 -- Pierre Gruet <pgt@debian.org>  Sat, 17 Dec 2022 11:58:47 +0100

openturns (1.20-6) unstable; urgency=medium

  * Patching code to comply with primesieve 11 interface
  * Raising Standards version to 4.6.2 (no change)

 -- Pierre Gruet <pgt@debian.org>  Sat, 17 Dec 2022 06:54:00 +0100

openturns (1.20-5) unstable; urgency=medium

  * Skipping autopkgtest on i386

 -- Pierre Gruet <pgt@debian.org>  Fri, 25 Nov 2022 12:48:08 +0100

openturns (1.20-4) unstable; urgency=medium

  * Adding autopkgtests
  * Marking the scalar_comparison_in_Gamma_distribution patch as Forwarded
  * Fixing spelling issues

 -- Pierre Gruet <pgt@debian.org>  Thu, 24 Nov 2022 06:14:17 +0100

openturns (1.20-3) experimental; urgency=medium

  * Ignoring the comparisons to reference outputs for:
    - the Python counterpart of TruncatedNormal_std
    - the Python MetaModelAlgorithm_std test

 -- Pierre Gruet <pgt@debian.org>  Tue, 22 Nov 2022 22:17:38 +0100

openturns (1.20-2) experimental; urgency=medium

  * Converting sample in t_DistributionFactory_std.py from integer to float
    when passing it to the factory
  * Skipping the comparison of the outputs of the cpp_TruncatedNormal_std.cxx
    test to a reference because of rounding issues

 -- Pierre Gruet <pgt@debian.org>  Tue, 22 Nov 2022 14:38:59 +0100

openturns (1.20-1) experimental; urgency=medium

  * New upstream version 1.20
  * Refreshing patches
  * Bumping SONAME to libOT0.21, new binary package
  * Refreshing d/copyright
  * Updating the dependencies of the -dev package

 -- Pierre Gruet <pgt@debian.org>  Sat, 19 Nov 2022 21:09:14 +0100

openturns (1.19-4~exp0) experimental; urgency=medium

  * Removing the -examples package as sphinx documentation on the website is
    much nicer and more helpful
  * Stopping shipping the static library
  * Adding a Lintian override for a false positive about a spelling mistake
  * Simplifying d/rules
  * Removing python3-dev from the dependencies of the -dev package
  * Comparing the (double) parameters of the Gamma distribution by testing the
    difference is small instead of using the == operator

 -- Pierre Gruet <pgt@debian.org>  Fri, 14 Oct 2022 14:29:57 +0200

=== debian/control ===
Source: openturns
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Pierre Gruet <pgt@debian.org>
Build-Depends: debhelper-compat (= 13),
               bison,
               cmake,
               coinor-libbonmin-dev,
               coinor-libipopt-dev,
               dh-python,
               gfortran,
               flex,
               libblas-dev,
               libboost-math-dev,
               libceres-dev,
               libcminpack-dev,
               libdlib-dev,
               libhdf5-dev,
               libhmat-oss-dev (>= 1.7.1),
               liblapack-dev,
               libmpc-dev,
               libmpfr-dev,
               libmuparser-dev,
               libnlopt-cxx-dev,
               libpagmo-dev,
               libprimesieve-dev,
               libspectra-dev,
               libtbb-dev,
               libxml2-dev,
               python3-dev,
               swig
Standards-Version: 4.6.2
Homepage: https://openturns.github.io/www/
Vcs-Browser: https://salsa.debian.org/science-team/openturns
Vcs-Git: https://salsa.debian.org/science-team/openturns.git
Rules-Requires-Root: no

Package: libopenturns0.21
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         openturns-common
Suggests: python3-openturns
Description: dynamic libraries for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * define the outputs of interest and decision criteria;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity
  * rank the sources of uncertainty
 .
 Targeted users are all engineers who want to introduce the
 probabilistic dimension in their so far deterministic studies.
 .
 This package provides the dynamic libraries.

Package: libopenturns-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libopenturns0.21 (= ${binary:Version}),
         libceres-dev,
         libhmat-oss-dev
Description: headers and development libraries for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 Targeted users are all engineers who want to introduce the
 probabilistic dimension in their so far deterministic studies.
 .
 This package contains development files needed to build OpenTURNS applications.

Package: openturns-common
Architecture: all
Depends: ${shlibs:Depends},
         ${misc:Depends}
Multi-Arch: foreign
Description: generic tool to treat and quantify uncertainties (common files)
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 Targeted users are all engineers who want to introduce the
 probabilistic dimension in their so far deterministic studies.
 .
 This package contains the configuration file for the versioned library
 package.

Package: python3-openturns
Section: python
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libopenturns0.21 (= ${binary:Version}),
         ${python3:Depends}
Provides: ${python3:Provides}
Suggests: python3-matplotlib,
          python3-scipy
Description: Python3 front-end of OpenTURNS (aka TUI)
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 Targeted users are all engineers who want to introduce the
 probabilistic dimension in their so far deterministic studies.
 .
 This package provides the Python3 bindings to the library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)
DPKG_EXPORT_BUILDFLAGS = 1
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Getting the number of jobs for the Debian build to transmit it to CMake.
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	test_makeflags = -j$(NUMJOBS)
endif

# Disabling tbb on s390x until Debian bug #1009361 is fixed.
ifeq ($(shell dpkg --print-architecture),s390x)
    with_tbb := -DUSE_TBB:BOOL=OFF
else
    with_tbb := -DUSE_TBB:BOOL=ON
endif

# Discarding the following flaky tests on armel.
ifeq ($(shell dpkg --print-architecture),armel)
    test_discardflags := -E \\\"FunctionalChaos_.*|KrigingAlgorithm_std|MetaModelValidation_std\\\"
endif

BUILD_DATE = $(shell date --utc --date="@$(SOURCE_DATE_EPOCH)" "+%a, %d %b %Y %H:%M:%S %z")

%:
	dh $@ --buildsystem=cmake --with python3

override_dh_auto_configure:
	dh_auto_configure -Bbuilddir -- \
            $(with_tbb) \
            -Dot_configure_date:STRING='$(BUILD_DATE)' \
            -DUSE_SPHINX:BOOL=OFF \
            -DCMAKE_SKIP_INSTALL_RPATH:BOOL=ON \
            -DCMAKE_INSTALL_PREFIX:PATH=/usr \
            -DCMAKE_INSTALL_LIBDIR:PATH="/usr/lib/$(DEB_HOST_MULTIARCH)" \
            -DINSTALL_DESTDIR:PATH=$(CURDIR)/debian/tmp \
	        -DCMAKE_UNITY_BUILD=ON -DCMAKE_UNITY_BUILD_BATCH_SIZE=32 \
            -DSWIG_COMPILE_FLAGS:STRING='-O1'

override_dh_auto_build:
	$(MAKE) $(test_makeflags) -C builddir/lib
	$(MAKE) -j1 -C builddir/python
	$(MAKE) $(test_makeflags) -C builddir

override_dh_auto_install:
	dh_auto_install -Bbuilddir
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	eval "LD_LIBRARY_PATH=$${LD_LIBRARY_PATH:+$${LD_LIBRARY_PATH}:}$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
	  CTEST_OUTPUT_ON_FAILURE=1 \
	  $(MAKE) $(test_makeflags) -C builddir test ARGS=\"$(test_makeflags) $(test_discardflags) -R pyinstallcheck\""
endif

override_dh_auto_test:
	# 'make test' does not build binary tests
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) $(test_makeflags) -C builddir tests
	eval "CTEST_OUTPUT_ON_FAILURE=1 \
	  $(MAKE) -C builddir test ARGS=\"$(test_makeflags) $(test_discardflags) -R cppcheck\""
endif
